# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates. All rights reserved.

SDK_client_map = {
    "data_safe.activate_target_database": "oci.data_safe.DataSafeClient.activate_target_database",
    "data_safe.add_masking_columns_from_sdm": "oci.data_safe.DataSafeClient.add_masking_columns_from_sdm",
    "data_safe.alerts_update": "oci.data_safe.DataSafeClient.alerts_update",
    "data_safe.apply_discovery_job_results": "oci.data_safe.DataSafeClient.apply_discovery_job_results",
    "data_safe.apply_sdm_masking_policy_difference": "oci.data_safe.DataSafeClient.apply_sdm_masking_policy_difference",
    "data_safe.bulk_create_sensitive_types": "oci.data_safe.DataSafeClient.bulk_create_sensitive_types",
    "data_safe.bulk_create_sql_firewall_allowed_sqls": "oci.data_safe.DataSafeClient.bulk_create_sql_firewall_allowed_sqls",
    "data_safe.bulk_delete_sql_firewall_allowed_sqls": "oci.data_safe.DataSafeClient.bulk_delete_sql_firewall_allowed_sqls",
    "data_safe.calculate_audit_volume_available": "oci.data_safe.DataSafeClient.calculate_audit_volume_available",
    "data_safe.calculate_audit_volume_collected": "oci.data_safe.DataSafeClient.calculate_audit_volume_collected",
    "data_safe.cancel_work_request": "oci.data_safe.DataSafeClient.cancel_work_request",
    "data_safe.change_alert_compartment": "oci.data_safe.DataSafeClient.change_alert_compartment",
    "data_safe.change_alert_policy_compartment": "oci.data_safe.DataSafeClient.change_alert_policy_compartment",
    "data_safe.change_audit_archive_retrieval_compartment": "oci.data_safe.DataSafeClient.change_audit_archive_retrieval_compartment",
    "data_safe.change_audit_policy_compartment": "oci.data_safe.DataSafeClient.change_audit_policy_compartment",
    "data_safe.change_audit_profile_compartment": "oci.data_safe.DataSafeClient.change_audit_profile_compartment",
    "data_safe.change_data_safe_private_endpoint_compartment": "oci.data_safe.DataSafeClient.change_data_safe_private_endpoint_compartment",
    "data_safe.change_database_security_config_compartment": "oci.data_safe.DataSafeClient.change_database_security_config_compartment",
    "data_safe.change_discovery_job_compartment": "oci.data_safe.DataSafeClient.change_discovery_job_compartment",
    "data_safe.change_library_masking_format_compartment": "oci.data_safe.DataSafeClient.change_library_masking_format_compartment",
    "data_safe.change_masking_policy_compartment": "oci.data_safe.DataSafeClient.change_masking_policy_compartment",
    "data_safe.change_masking_policy_health_report_compartment": "oci.data_safe.DataSafeClient.change_masking_policy_health_report_compartment",
    "data_safe.change_on_prem_connector_compartment": "oci.data_safe.DataSafeClient.change_on_prem_connector_compartment",
    "data_safe.change_report_compartment": "oci.data_safe.DataSafeClient.change_report_compartment",
    "data_safe.change_report_definition_compartment": "oci.data_safe.DataSafeClient.change_report_definition_compartment",
    "data_safe.change_retention": "oci.data_safe.DataSafeClient.change_retention",
    "data_safe.change_sdm_masking_policy_difference_compartment": "oci.data_safe.DataSafeClient.change_sdm_masking_policy_difference_compartment",
    "data_safe.change_security_assessment_compartment": "oci.data_safe.DataSafeClient.change_security_assessment_compartment",
    "data_safe.change_security_policy_compartment": "oci.data_safe.DataSafeClient.change_security_policy_compartment",
    "data_safe.change_security_policy_deployment_compartment": "oci.data_safe.DataSafeClient.change_security_policy_deployment_compartment",
    "data_safe.change_sensitive_data_model_compartment": "oci.data_safe.DataSafeClient.change_sensitive_data_model_compartment",
    "data_safe.change_sensitive_type_compartment": "oci.data_safe.DataSafeClient.change_sensitive_type_compartment",
    "data_safe.change_sensitive_type_group_compartment": "oci.data_safe.DataSafeClient.change_sensitive_type_group_compartment",
    "data_safe.change_sensitive_types_export_compartment": "oci.data_safe.DataSafeClient.change_sensitive_types_export_compartment",
    "data_safe.change_sql_collection_compartment": "oci.data_safe.DataSafeClient.change_sql_collection_compartment",
    "data_safe.change_sql_firewall_policy_compartment": "oci.data_safe.DataSafeClient.change_sql_firewall_policy_compartment",
    "data_safe.change_target_alert_policy_association_compartment": "oci.data_safe.DataSafeClient.change_target_alert_policy_association_compartment",
    "data_safe.change_target_database_compartment": "oci.data_safe.DataSafeClient.change_target_database_compartment",
    "data_safe.change_user_assessment_compartment": "oci.data_safe.DataSafeClient.change_user_assessment_compartment",
    "data_safe.compare_security_assessment": "oci.data_safe.DataSafeClient.compare_security_assessment",
    "data_safe.compare_user_assessment": "oci.data_safe.DataSafeClient.compare_user_assessment",
    "data_safe.create_alert_policy": "oci.data_safe.DataSafeClient.create_alert_policy",
    "data_safe.create_alert_policy_rule": "oci.data_safe.DataSafeClient.create_alert_policy_rule",
    "data_safe.create_audit_archive_retrieval": "oci.data_safe.DataSafeClient.create_audit_archive_retrieval",
    "data_safe.create_data_safe_private_endpoint": "oci.data_safe.DataSafeClient.create_data_safe_private_endpoint",
    "data_safe.create_discovery_job": "oci.data_safe.DataSafeClient.create_discovery_job",
    "data_safe.create_library_masking_format": "oci.data_safe.DataSafeClient.create_library_masking_format",
    "data_safe.create_masking_column": "oci.data_safe.DataSafeClient.create_masking_column",
    "data_safe.create_masking_policy": "oci.data_safe.DataSafeClient.create_masking_policy",
    "data_safe.create_on_prem_connector": "oci.data_safe.DataSafeClient.create_on_prem_connector",
    "data_safe.create_peer_target_database": "oci.data_safe.DataSafeClient.create_peer_target_database",
    "data_safe.create_referential_relation": "oci.data_safe.DataSafeClient.create_referential_relation",
    "data_safe.create_report_definition": "oci.data_safe.DataSafeClient.create_report_definition",
    "data_safe.create_sdm_masking_policy_difference": "oci.data_safe.DataSafeClient.create_sdm_masking_policy_difference",
    "data_safe.create_security_assessment": "oci.data_safe.DataSafeClient.create_security_assessment",
    "data_safe.create_sensitive_column": "oci.data_safe.DataSafeClient.create_sensitive_column",
    "data_safe.create_sensitive_data_model": "oci.data_safe.DataSafeClient.create_sensitive_data_model",
    "data_safe.create_sensitive_type": "oci.data_safe.DataSafeClient.create_sensitive_type",
    "data_safe.create_sensitive_type_group": "oci.data_safe.DataSafeClient.create_sensitive_type_group",
    "data_safe.create_sensitive_types_export": "oci.data_safe.DataSafeClient.create_sensitive_types_export",
    "data_safe.create_sql_collection": "oci.data_safe.DataSafeClient.create_sql_collection",
    "data_safe.create_target_alert_policy_association": "oci.data_safe.DataSafeClient.create_target_alert_policy_association",
    "data_safe.create_target_database": "oci.data_safe.DataSafeClient.create_target_database",
    "data_safe.create_user_assessment": "oci.data_safe.DataSafeClient.create_user_assessment",
    "data_safe.deactivate_target_database": "oci.data_safe.DataSafeClient.deactivate_target_database",
    "data_safe.delete_alert_policy": "oci.data_safe.DataSafeClient.delete_alert_policy",
    "data_safe.delete_alert_policy_rule": "oci.data_safe.DataSafeClient.delete_alert_policy_rule",
    "data_safe.delete_audit_archive_retrieval": "oci.data_safe.DataSafeClient.delete_audit_archive_retrieval",
    "data_safe.delete_audit_trail": "oci.data_safe.DataSafeClient.delete_audit_trail",
    "data_safe.delete_data_safe_private_endpoint": "oci.data_safe.DataSafeClient.delete_data_safe_private_endpoint",
    "data_safe.delete_discovery_job": "oci.data_safe.DataSafeClient.delete_discovery_job",
    "data_safe.delete_discovery_job_result": "oci.data_safe.DataSafeClient.delete_discovery_job_result",
    "data_safe.delete_library_masking_format": "oci.data_safe.DataSafeClient.delete_library_masking_format",
    "data_safe.delete_masking_column": "oci.data_safe.DataSafeClient.delete_masking_column",
    "data_safe.delete_masking_policy": "oci.data_safe.DataSafeClient.delete_masking_policy",
    "data_safe.delete_masking_policy_health_report": "oci.data_safe.DataSafeClient.delete_masking_policy_health_report",
    "data_safe.delete_masking_report": "oci.data_safe.DataSafeClient.delete_masking_report",
    "data_safe.delete_on_prem_connector": "oci.data_safe.DataSafeClient.delete_on_prem_connector",
    "data_safe.delete_peer_target_database": "oci.data_safe.DataSafeClient.delete_peer_target_database",
    "data_safe.delete_referential_relation": "oci.data_safe.DataSafeClient.delete_referential_relation",
    "data_safe.delete_report_definition": "oci.data_safe.DataSafeClient.delete_report_definition",
    "data_safe.delete_sdm_masking_policy_difference": "oci.data_safe.DataSafeClient.delete_sdm_masking_policy_difference",
    "data_safe.delete_security_assessment": "oci.data_safe.DataSafeClient.delete_security_assessment",
    "data_safe.delete_sensitive_column": "oci.data_safe.DataSafeClient.delete_sensitive_column",
    "data_safe.delete_sensitive_data_model": "oci.data_safe.DataSafeClient.delete_sensitive_data_model",
    "data_safe.delete_sensitive_type": "oci.data_safe.DataSafeClient.delete_sensitive_type",
    "data_safe.delete_sensitive_type_group": "oci.data_safe.DataSafeClient.delete_sensitive_type_group",
    "data_safe.delete_sensitive_types_export": "oci.data_safe.DataSafeClient.delete_sensitive_types_export",
    "data_safe.delete_sql_collection": "oci.data_safe.DataSafeClient.delete_sql_collection",
    "data_safe.delete_sql_firewall_allowed_sql": "oci.data_safe.DataSafeClient.delete_sql_firewall_allowed_sql",
    "data_safe.delete_sql_firewall_policy": "oci.data_safe.DataSafeClient.delete_sql_firewall_policy",
    "data_safe.delete_target_alert_policy_association": "oci.data_safe.DataSafeClient.delete_target_alert_policy_association",
    "data_safe.delete_target_database": "oci.data_safe.DataSafeClient.delete_target_database",
    "data_safe.delete_user_assessment": "oci.data_safe.DataSafeClient.delete_user_assessment",
    "data_safe.discover_audit_trails": "oci.data_safe.DataSafeClient.discover_audit_trails",
    "data_safe.download_discovery_report": "oci.data_safe.DataSafeClient.download_discovery_report",
    "data_safe.download_masking_log": "oci.data_safe.DataSafeClient.download_masking_log",
    "data_safe.download_masking_policy": "oci.data_safe.DataSafeClient.download_masking_policy",
    "data_safe.download_masking_report": "oci.data_safe.DataSafeClient.download_masking_report",
    "data_safe.download_privilege_script": "oci.data_safe.DataSafeClient.download_privilege_script",
    "data_safe.download_security_assessment_report": "oci.data_safe.DataSafeClient.download_security_assessment_report",
    "data_safe.download_sensitive_data_model": "oci.data_safe.DataSafeClient.download_sensitive_data_model",
    "data_safe.download_sensitive_types_export": "oci.data_safe.DataSafeClient.download_sensitive_types_export",
    "data_safe.download_user_assessment_report": "oci.data_safe.DataSafeClient.download_user_assessment_report",
    "data_safe.enable_data_safe_configuration": "oci.data_safe.DataSafeClient.enable_data_safe_configuration",
    "data_safe.generate_discovery_report_for_download": "oci.data_safe.DataSafeClient.generate_discovery_report_for_download",
    "data_safe.generate_health_report": "oci.data_safe.DataSafeClient.generate_health_report",
    "data_safe.generate_masking_policy_for_download": "oci.data_safe.DataSafeClient.generate_masking_policy_for_download",
    "data_safe.generate_masking_report_for_download": "oci.data_safe.DataSafeClient.generate_masking_report_for_download",
    "data_safe.generate_on_prem_connector_configuration": "oci.data_safe.DataSafeClient.generate_on_prem_connector_configuration",
    "data_safe.generate_report": "oci.data_safe.DataSafeClient.generate_report",
    "data_safe.generate_security_assessment_report": "oci.data_safe.DataSafeClient.generate_security_assessment_report",
    "data_safe.generate_sensitive_data_model_for_download": "oci.data_safe.DataSafeClient.generate_sensitive_data_model_for_download",
    "data_safe.generate_sql_firewall_policy": "oci.data_safe.DataSafeClient.generate_sql_firewall_policy",
    "data_safe.generate_user_assessment_report": "oci.data_safe.DataSafeClient.generate_user_assessment_report",
    "data_safe.get_alert": "oci.data_safe.DataSafeClient.get_alert",
    "data_safe.get_alert_policy": "oci.data_safe.DataSafeClient.get_alert_policy",
    "data_safe.get_alert_policy_rule": "oci.data_safe.DataSafeClient.get_alert_policy_rule",
    "data_safe.get_audit_archive_retrieval": "oci.data_safe.DataSafeClient.get_audit_archive_retrieval",
    "data_safe.get_audit_policy": "oci.data_safe.DataSafeClient.get_audit_policy",
    "data_safe.get_audit_profile": "oci.data_safe.DataSafeClient.get_audit_profile",
    "data_safe.get_audit_trail": "oci.data_safe.DataSafeClient.get_audit_trail",
    "data_safe.get_compatible_formats_for_data_types": "oci.data_safe.DataSafeClient.get_compatible_formats_for_data_types",
    "data_safe.get_compatible_formats_for_sensitive_types": "oci.data_safe.DataSafeClient.get_compatible_formats_for_sensitive_types",
    "data_safe.get_data_safe_configuration": "oci.data_safe.DataSafeClient.get_data_safe_configuration",
    "data_safe.get_data_safe_private_endpoint": "oci.data_safe.DataSafeClient.get_data_safe_private_endpoint",
    "data_safe.get_database_security_config": "oci.data_safe.DataSafeClient.get_database_security_config",
    "data_safe.get_database_table_access_entry": "oci.data_safe.DataSafeClient.get_database_table_access_entry",
    "data_safe.get_database_view_access_entry": "oci.data_safe.DataSafeClient.get_database_view_access_entry",
    "data_safe.get_difference_column": "oci.data_safe.DataSafeClient.get_difference_column",
    "data_safe.get_discovery_job": "oci.data_safe.DataSafeClient.get_discovery_job",
    "data_safe.get_discovery_job_result": "oci.data_safe.DataSafeClient.get_discovery_job_result",
    "data_safe.get_library_masking_format": "oci.data_safe.DataSafeClient.get_library_masking_format",
    "data_safe.get_masking_column": "oci.data_safe.DataSafeClient.get_masking_column",
    "data_safe.get_masking_policy": "oci.data_safe.DataSafeClient.get_masking_policy",
    "data_safe.get_masking_policy_health_report": "oci.data_safe.DataSafeClient.get_masking_policy_health_report",
    "data_safe.get_masking_report": "oci.data_safe.DataSafeClient.get_masking_report",
    "data_safe.get_on_prem_connector": "oci.data_safe.DataSafeClient.get_on_prem_connector",
    "data_safe.get_peer_target_database": "oci.data_safe.DataSafeClient.get_peer_target_database",
    "data_safe.get_profile": "oci.data_safe.DataSafeClient.get_profile",
    "data_safe.get_referential_relation": "oci.data_safe.DataSafeClient.get_referential_relation",
    "data_safe.get_report": "oci.data_safe.DataSafeClient.get_report",
    "data_safe.get_report_content": "oci.data_safe.DataSafeClient.get_report_content",
    "data_safe.get_report_definition": "oci.data_safe.DataSafeClient.get_report_definition",
    "data_safe.get_sdm_masking_policy_difference": "oci.data_safe.DataSafeClient.get_sdm_masking_policy_difference",
    "data_safe.get_security_assessment": "oci.data_safe.DataSafeClient.get_security_assessment",
    "data_safe.get_security_assessment_comparison": "oci.data_safe.DataSafeClient.get_security_assessment_comparison",
    "data_safe.get_security_policy": "oci.data_safe.DataSafeClient.get_security_policy",
    "data_safe.get_security_policy_deployment": "oci.data_safe.DataSafeClient.get_security_policy_deployment",
    "data_safe.get_security_policy_entry_state": "oci.data_safe.DataSafeClient.get_security_policy_entry_state",
    "data_safe.get_security_policy_report": "oci.data_safe.DataSafeClient.get_security_policy_report",
    "data_safe.get_sensitive_column": "oci.data_safe.DataSafeClient.get_sensitive_column",
    "data_safe.get_sensitive_data_model": "oci.data_safe.DataSafeClient.get_sensitive_data_model",
    "data_safe.get_sensitive_type": "oci.data_safe.DataSafeClient.get_sensitive_type",
    "data_safe.get_sensitive_type_group": "oci.data_safe.DataSafeClient.get_sensitive_type_group",
    "data_safe.get_sensitive_types_export": "oci.data_safe.DataSafeClient.get_sensitive_types_export",
    "data_safe.get_sql_collection": "oci.data_safe.DataSafeClient.get_sql_collection",
    "data_safe.get_sql_firewall_allowed_sql": "oci.data_safe.DataSafeClient.get_sql_firewall_allowed_sql",
    "data_safe.get_sql_firewall_policy": "oci.data_safe.DataSafeClient.get_sql_firewall_policy",
    "data_safe.get_target_alert_policy_association": "oci.data_safe.DataSafeClient.get_target_alert_policy_association",
    "data_safe.get_target_database": "oci.data_safe.DataSafeClient.get_target_database",
    "data_safe.get_user_assessment": "oci.data_safe.DataSafeClient.get_user_assessment",
    "data_safe.get_user_assessment_comparison": "oci.data_safe.DataSafeClient.get_user_assessment_comparison",
    "data_safe.get_work_request": "oci.data_safe.DataSafeClient.get_work_request",
    "data_safe.list_alert_analytics": "oci.data_safe.DataSafeClient.list_alert_analytics",
    "data_safe.list_alert_policies": "oci.data_safe.DataSafeClient.list_alert_policies",
    "data_safe.list_alert_policy_rules": "oci.data_safe.DataSafeClient.list_alert_policy_rules",
    "data_safe.list_alerts": "oci.data_safe.DataSafeClient.list_alerts",
    "data_safe.list_audit_archive_retrievals": "oci.data_safe.DataSafeClient.list_audit_archive_retrievals",
    "data_safe.list_audit_event_analytics": "oci.data_safe.DataSafeClient.list_audit_event_analytics",
    "data_safe.list_audit_events": "oci.data_safe.DataSafeClient.list_audit_events",
    "data_safe.list_audit_policies": "oci.data_safe.DataSafeClient.list_audit_policies",
    "data_safe.list_audit_policy_analytics": "oci.data_safe.DataSafeClient.list_audit_policy_analytics",
    "data_safe.list_audit_profile_analytics": "oci.data_safe.DataSafeClient.list_audit_profile_analytics",
    "data_safe.list_audit_profiles": "oci.data_safe.DataSafeClient.list_audit_profiles",
    "data_safe.list_audit_trail_analytics": "oci.data_safe.DataSafeClient.list_audit_trail_analytics",
    "data_safe.list_audit_trails": "oci.data_safe.DataSafeClient.list_audit_trails",
    "data_safe.list_available_audit_volumes": "oci.data_safe.DataSafeClient.list_available_audit_volumes",
    "data_safe.list_collected_audit_volumes": "oci.data_safe.DataSafeClient.list_collected_audit_volumes",
    "data_safe.list_columns": "oci.data_safe.DataSafeClient.list_columns",
    "data_safe.list_data_safe_private_endpoints": "oci.data_safe.DataSafeClient.list_data_safe_private_endpoints",
    "data_safe.list_database_security_configs": "oci.data_safe.DataSafeClient.list_database_security_configs",
    "data_safe.list_database_table_access_entries": "oci.data_safe.DataSafeClient.list_database_table_access_entries",
    "data_safe.list_database_view_access_entries": "oci.data_safe.DataSafeClient.list_database_view_access_entries",
    "data_safe.list_difference_columns": "oci.data_safe.DataSafeClient.list_difference_columns",
    "data_safe.list_discovery_analytics": "oci.data_safe.DataSafeClient.list_discovery_analytics",
    "data_safe.list_discovery_job_results": "oci.data_safe.DataSafeClient.list_discovery_job_results",
    "data_safe.list_discovery_jobs": "oci.data_safe.DataSafeClient.list_discovery_jobs",
    "data_safe.list_finding_analytics": "oci.data_safe.DataSafeClient.list_finding_analytics",
    "data_safe.list_findings": "oci.data_safe.DataSafeClient.list_findings",
    "data_safe.list_findings_change_audit_logs": "oci.data_safe.DataSafeClient.list_findings_change_audit_logs",
    "data_safe.list_grants": "oci.data_safe.DataSafeClient.list_grants",
    "data_safe.list_grouped_sensitive_types": "oci.data_safe.DataSafeClient.list_grouped_sensitive_types",
    "data_safe.list_library_masking_formats": "oci.data_safe.DataSafeClient.list_library_masking_formats",
    "data_safe.list_masked_columns": "oci.data_safe.DataSafeClient.list_masked_columns",
    "data_safe.list_masking_analytics": "oci.data_safe.DataSafeClient.list_masking_analytics",
    "data_safe.list_masking_columns": "oci.data_safe.DataSafeClient.list_masking_columns",
    "data_safe.list_masking_errors": "oci.data_safe.DataSafeClient.list_masking_errors",
    "data_safe.list_masking_objects": "oci.data_safe.DataSafeClient.list_masking_objects",
    "data_safe.list_masking_policies": "oci.data_safe.DataSafeClient.list_masking_policies",
    "data_safe.list_masking_policy_health_report_logs": "oci.data_safe.DataSafeClient.list_masking_policy_health_report_logs",
    "data_safe.list_masking_policy_health_reports": "oci.data_safe.DataSafeClient.list_masking_policy_health_reports",
    "data_safe.list_masking_policy_referential_relations": "oci.data_safe.DataSafeClient.list_masking_policy_referential_relations",
    "data_safe.list_masking_reports": "oci.data_safe.DataSafeClient.list_masking_reports",
    "data_safe.list_masking_schemas": "oci.data_safe.DataSafeClient.list_masking_schemas",
    "data_safe.list_on_prem_connectors": "oci.data_safe.DataSafeClient.list_on_prem_connectors",
    "data_safe.list_password_expiry_date_analytics": "oci.data_safe.DataSafeClient.list_password_expiry_date_analytics",
    "data_safe.list_peer_target_databases": "oci.data_safe.DataSafeClient.list_peer_target_databases",
    "data_safe.list_profile_analytics": "oci.data_safe.DataSafeClient.list_profile_analytics",
    "data_safe.list_profile_summaries": "oci.data_safe.DataSafeClient.list_profile_summaries",
    "data_safe.list_referential_relations": "oci.data_safe.DataSafeClient.list_referential_relations",
    "data_safe.list_report_definitions": "oci.data_safe.DataSafeClient.list_report_definitions",
    "data_safe.list_reports": "oci.data_safe.DataSafeClient.list_reports",
    "data_safe.list_role_grant_paths": "oci.data_safe.DataSafeClient.list_role_grant_paths",
    "data_safe.list_roles": "oci.data_safe.DataSafeClient.list_roles",
    "data_safe.list_schemas": "oci.data_safe.DataSafeClient.list_schemas",
    "data_safe.list_sdm_masking_policy_differences": "oci.data_safe.DataSafeClient.list_sdm_masking_policy_differences",
    "data_safe.list_security_assessments": "oci.data_safe.DataSafeClient.list_security_assessments",
    "data_safe.list_security_feature_analytics": "oci.data_safe.DataSafeClient.list_security_feature_analytics",
    "data_safe.list_security_features": "oci.data_safe.DataSafeClient.list_security_features",
    "data_safe.list_security_policies": "oci.data_safe.DataSafeClient.list_security_policies",
    "data_safe.list_security_policy_deployments": "oci.data_safe.DataSafeClient.list_security_policy_deployments",
    "data_safe.list_security_policy_entry_states": "oci.data_safe.DataSafeClient.list_security_policy_entry_states",
    "data_safe.list_security_policy_reports": "oci.data_safe.DataSafeClient.list_security_policy_reports",
    "data_safe.list_sensitive_column_analytics": "oci.data_safe.DataSafeClient.list_sensitive_column_analytics",
    "data_safe.list_sensitive_columns": "oci.data_safe.DataSafeClient.list_sensitive_columns",
    "data_safe.list_sensitive_data_model_sensitive_types": "oci.data_safe.DataSafeClient.list_sensitive_data_model_sensitive_types",
    "data_safe.list_sensitive_data_models": "oci.data_safe.DataSafeClient.list_sensitive_data_models",
    "data_safe.list_sensitive_objects": "oci.data_safe.DataSafeClient.list_sensitive_objects",
    "data_safe.list_sensitive_schemas": "oci.data_safe.DataSafeClient.list_sensitive_schemas",
    "data_safe.list_sensitive_type_groups": "oci.data_safe.DataSafeClient.list_sensitive_type_groups",
    "data_safe.list_sensitive_types": "oci.data_safe.DataSafeClient.list_sensitive_types",
    "data_safe.list_sensitive_types_exports": "oci.data_safe.DataSafeClient.list_sensitive_types_exports",
    "data_safe.list_sql_collection_analytics": "oci.data_safe.DataSafeClient.list_sql_collection_analytics",
    "data_safe.list_sql_collection_log_insights": "oci.data_safe.DataSafeClient.list_sql_collection_log_insights",
    "data_safe.list_sql_collections": "oci.data_safe.DataSafeClient.list_sql_collections",
    "data_safe.list_sql_firewall_allowed_sql_analytics": "oci.data_safe.DataSafeClient.list_sql_firewall_allowed_sql_analytics",
    "data_safe.list_sql_firewall_allowed_sqls": "oci.data_safe.DataSafeClient.list_sql_firewall_allowed_sqls",
    "data_safe.list_sql_firewall_policies": "oci.data_safe.DataSafeClient.list_sql_firewall_policies",
    "data_safe.list_sql_firewall_policy_analytics": "oci.data_safe.DataSafeClient.list_sql_firewall_policy_analytics",
    "data_safe.list_sql_firewall_violation_analytics": "oci.data_safe.DataSafeClient.list_sql_firewall_violation_analytics",
    "data_safe.list_sql_firewall_violations": "oci.data_safe.DataSafeClient.list_sql_firewall_violations",
    "data_safe.list_tables": "oci.data_safe.DataSafeClient.list_tables",
    "data_safe.list_target_alert_policy_associations": "oci.data_safe.DataSafeClient.list_target_alert_policy_associations",
    "data_safe.list_target_databases": "oci.data_safe.DataSafeClient.list_target_databases",
    "data_safe.list_user_access_analytics": "oci.data_safe.DataSafeClient.list_user_access_analytics",
    "data_safe.list_user_analytics": "oci.data_safe.DataSafeClient.list_user_analytics",
    "data_safe.list_user_assessments": "oci.data_safe.DataSafeClient.list_user_assessments",
    "data_safe.list_users": "oci.data_safe.DataSafeClient.list_users",
    "data_safe.list_work_request_errors": "oci.data_safe.DataSafeClient.list_work_request_errors",
    "data_safe.list_work_request_logs": "oci.data_safe.DataSafeClient.list_work_request_logs",
    "data_safe.list_work_requests": "oci.data_safe.DataSafeClient.list_work_requests",
    "data_safe.mask_data": "oci.data_safe.DataSafeClient.mask_data",
    "data_safe.modify_global_settings": "oci.data_safe.DataSafeClient.modify_global_settings",
    "data_safe.patch_alerts": "oci.data_safe.DataSafeClient.patch_alerts",
    "data_safe.patch_discovery_job_results": "oci.data_safe.DataSafeClient.patch_discovery_job_results",
    "data_safe.patch_grouped_sensitive_types": "oci.data_safe.DataSafeClient.patch_grouped_sensitive_types",
    "data_safe.patch_masking_columns": "oci.data_safe.DataSafeClient.patch_masking_columns",
    "data_safe.patch_sdm_masking_policy_difference_columns": "oci.data_safe.DataSafeClient.patch_sdm_masking_policy_difference_columns",
    "data_safe.patch_sensitive_columns": "oci.data_safe.DataSafeClient.patch_sensitive_columns",
    "data_safe.patch_sql_firewall_allowed_sql": "oci.data_safe.DataSafeClient.patch_sql_firewall_allowed_sql",
    "data_safe.patch_target_alert_policy_association": "oci.data_safe.DataSafeClient.patch_target_alert_policy_association",
    "data_safe.provision_audit_policy": "oci.data_safe.DataSafeClient.provision_audit_policy",
    "data_safe.purge_sql_collection_logs": "oci.data_safe.DataSafeClient.purge_sql_collection_logs",
    "data_safe.refresh_database_security_configuration": "oci.data_safe.DataSafeClient.refresh_database_security_configuration",
    "data_safe.refresh_security_assessment": "oci.data_safe.DataSafeClient.refresh_security_assessment",
    "data_safe.refresh_sql_collection_log_insights": "oci.data_safe.DataSafeClient.refresh_sql_collection_log_insights",
    "data_safe.refresh_target_database": "oci.data_safe.DataSafeClient.refresh_target_database",
    "data_safe.refresh_user_assessment": "oci.data_safe.DataSafeClient.refresh_user_assessment",
    "data_safe.remove_schedule_report": "oci.data_safe.DataSafeClient.remove_schedule_report",
    "data_safe.resume_audit_trail": "oci.data_safe.DataSafeClient.resume_audit_trail",
    "data_safe.resume_work_request": "oci.data_safe.DataSafeClient.resume_work_request",
    "data_safe.retrieve_audit_policies": "oci.data_safe.DataSafeClient.retrieve_audit_policies",
    "data_safe.schedule_report": "oci.data_safe.DataSafeClient.schedule_report",
    "data_safe.set_security_assessment_baseline": "oci.data_safe.DataSafeClient.set_security_assessment_baseline",
    "data_safe.set_user_assessment_baseline": "oci.data_safe.DataSafeClient.set_user_assessment_baseline",
    "data_safe.start_audit_trail": "oci.data_safe.DataSafeClient.start_audit_trail",
    "data_safe.start_sql_collection": "oci.data_safe.DataSafeClient.start_sql_collection",
    "data_safe.stop_audit_trail": "oci.data_safe.DataSafeClient.stop_audit_trail",
    "data_safe.stop_sql_collection": "oci.data_safe.DataSafeClient.stop_sql_collection",
    "data_safe.suspend_work_request": "oci.data_safe.DataSafeClient.suspend_work_request",
    "data_safe.unset_security_assessment_baseline": "oci.data_safe.DataSafeClient.unset_security_assessment_baseline",
    "data_safe.unset_user_assessment_baseline": "oci.data_safe.DataSafeClient.unset_user_assessment_baseline",
    "data_safe.update_alert": "oci.data_safe.DataSafeClient.update_alert",
    "data_safe.update_alert_policy": "oci.data_safe.DataSafeClient.update_alert_policy",
    "data_safe.update_alert_policy_rule": "oci.data_safe.DataSafeClient.update_alert_policy_rule",
    "data_safe.update_audit_archive_retrieval": "oci.data_safe.DataSafeClient.update_audit_archive_retrieval",
    "data_safe.update_audit_policy": "oci.data_safe.DataSafeClient.update_audit_policy",
    "data_safe.update_audit_profile": "oci.data_safe.DataSafeClient.update_audit_profile",
    "data_safe.update_audit_trail": "oci.data_safe.DataSafeClient.update_audit_trail",
    "data_safe.update_data_safe_private_endpoint": "oci.data_safe.DataSafeClient.update_data_safe_private_endpoint",
    "data_safe.update_database_security_config": "oci.data_safe.DataSafeClient.update_database_security_config",
    "data_safe.update_finding": "oci.data_safe.DataSafeClient.update_finding",
    "data_safe.update_library_masking_format": "oci.data_safe.DataSafeClient.update_library_masking_format",
    "data_safe.update_masking_column": "oci.data_safe.DataSafeClient.update_masking_column",
    "data_safe.update_masking_policy": "oci.data_safe.DataSafeClient.update_masking_policy",
    "data_safe.update_on_prem_connector": "oci.data_safe.DataSafeClient.update_on_prem_connector",
    "data_safe.update_on_prem_connector_wallet": "oci.data_safe.DataSafeClient.update_on_prem_connector_wallet",
    "data_safe.update_peer_target_database": "oci.data_safe.DataSafeClient.update_peer_target_database",
    "data_safe.update_report": "oci.data_safe.DataSafeClient.update_report",
    "data_safe.update_report_definition": "oci.data_safe.DataSafeClient.update_report_definition",
    "data_safe.update_sdm_masking_policy_difference": "oci.data_safe.DataSafeClient.update_sdm_masking_policy_difference",
    "data_safe.update_security_assessment": "oci.data_safe.DataSafeClient.update_security_assessment",
    "data_safe.update_security_policy": "oci.data_safe.DataSafeClient.update_security_policy",
    "data_safe.update_security_policy_deployment": "oci.data_safe.DataSafeClient.update_security_policy_deployment",
    "data_safe.update_sensitive_column": "oci.data_safe.DataSafeClient.update_sensitive_column",
    "data_safe.update_sensitive_data_model": "oci.data_safe.DataSafeClient.update_sensitive_data_model",
    "data_safe.update_sensitive_type": "oci.data_safe.DataSafeClient.update_sensitive_type",
    "data_safe.update_sensitive_type_group": "oci.data_safe.DataSafeClient.update_sensitive_type_group",
    "data_safe.update_sensitive_types_export": "oci.data_safe.DataSafeClient.update_sensitive_types_export",
    "data_safe.update_sql_collection": "oci.data_safe.DataSafeClient.update_sql_collection",
    "data_safe.update_sql_firewall_policy": "oci.data_safe.DataSafeClient.update_sql_firewall_policy",
    "data_safe.update_target_alert_policy_association": "oci.data_safe.DataSafeClient.update_target_alert_policy_association",
    "data_safe.update_target_database": "oci.data_safe.DataSafeClient.update_target_database",
    "data_safe.update_user_assessment": "oci.data_safe.DataSafeClient.update_user_assessment",
    "data_safe.upload_masking_policy": "oci.data_safe.DataSafeClient.upload_masking_policy",
    "data_safe.upload_sensitive_data_model": "oci.data_safe.DataSafeClient.upload_sensitive_data_model",
}
