# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates. All rights reserved.

SDK_client_map = {
    "data_science.activate_model": "oci.data_science.DataScienceClient.activate_model",
    "data_science.activate_model_deployment": "oci.data_science.DataScienceClient.activate_model_deployment",
    "data_science.activate_notebook_session": "oci.data_science.DataScienceClient.activate_notebook_session",
    "data_science.activate_schedule": "oci.data_science.DataScienceClient.activate_schedule",
    "data_science.cancel_job_run": "oci.data_science.DataScienceClient.cancel_job_run",
    "data_science.cancel_pipeline_run": "oci.data_science.DataScienceClient.cancel_pipeline_run",
    "data_science.cancel_work_request": "oci.data_science.DataScienceClient.cancel_work_request",
    "data_science.change_data_science_private_endpoint_compartment": "oci.data_science.DataScienceClient.change_data_science_private_endpoint_compartment",
    "data_science.change_job_compartment": "oci.data_science.DataScienceClient.change_job_compartment",
    "data_science.change_job_run_compartment": "oci.data_science.DataScienceClient.change_job_run_compartment",
    "data_science.change_ml_application_compartment": "oci.data_science.DataScienceClient.change_ml_application_compartment",
    "data_science.change_ml_application_implementation_compartment": "oci.data_science.DataScienceClient.change_ml_application_implementation_compartment",
    "data_science.change_ml_application_instance_compartment": "oci.data_science.DataScienceClient.change_ml_application_instance_compartment",
    "data_science.change_ml_application_instance_view_compartment": "oci.data_science.DataScienceClient.change_ml_application_instance_view_compartment",
    "data_science.change_model_compartment": "oci.data_science.DataScienceClient.change_model_compartment",
    "data_science.change_model_deployment_compartment": "oci.data_science.DataScienceClient.change_model_deployment_compartment",
    "data_science.change_model_version_set_compartment": "oci.data_science.DataScienceClient.change_model_version_set_compartment",
    "data_science.change_notebook_session_compartment": "oci.data_science.DataScienceClient.change_notebook_session_compartment",
    "data_science.change_pipeline_compartment": "oci.data_science.DataScienceClient.change_pipeline_compartment",
    "data_science.change_pipeline_run_compartment": "oci.data_science.DataScienceClient.change_pipeline_run_compartment",
    "data_science.change_project_compartment": "oci.data_science.DataScienceClient.change_project_compartment",
    "data_science.change_schedule_compartment": "oci.data_science.DataScienceClient.change_schedule_compartment",
    "data_science.create_data_science_private_endpoint": "oci.data_science.DataScienceClient.create_data_science_private_endpoint",
    "data_science.create_job": "oci.data_science.DataScienceClient.create_job",
    "data_science.create_job_artifact": "oci.data_science.DataScienceClient.create_job_artifact",
    "data_science.create_job_run": "oci.data_science.DataScienceClient.create_job_run",
    "data_science.create_ml_application": "oci.data_science.DataScienceClient.create_ml_application",
    "data_science.create_ml_application_implementation": "oci.data_science.DataScienceClient.create_ml_application_implementation",
    "data_science.create_ml_application_instance": "oci.data_science.DataScienceClient.create_ml_application_instance",
    "data_science.create_model": "oci.data_science.DataScienceClient.create_model",
    "data_science.create_model_artifact": "oci.data_science.DataScienceClient.create_model_artifact",
    "data_science.create_model_custom_metadatum_artifact": "oci.data_science.DataScienceClient.create_model_custom_metadatum_artifact",
    "data_science.create_model_defined_metadatum_artifact": "oci.data_science.DataScienceClient.create_model_defined_metadatum_artifact",
    "data_science.create_model_deployment": "oci.data_science.DataScienceClient.create_model_deployment",
    "data_science.create_model_provenance": "oci.data_science.DataScienceClient.create_model_provenance",
    "data_science.create_model_version_set": "oci.data_science.DataScienceClient.create_model_version_set",
    "data_science.create_notebook_session": "oci.data_science.DataScienceClient.create_notebook_session",
    "data_science.create_pipeline": "oci.data_science.DataScienceClient.create_pipeline",
    "data_science.create_pipeline_run": "oci.data_science.DataScienceClient.create_pipeline_run",
    "data_science.create_project": "oci.data_science.DataScienceClient.create_project",
    "data_science.create_schedule": "oci.data_science.DataScienceClient.create_schedule",
    "data_science.create_step_artifact": "oci.data_science.DataScienceClient.create_step_artifact",
    "data_science.deactivate_model": "oci.data_science.DataScienceClient.deactivate_model",
    "data_science.deactivate_model_deployment": "oci.data_science.DataScienceClient.deactivate_model_deployment",
    "data_science.deactivate_notebook_session": "oci.data_science.DataScienceClient.deactivate_notebook_session",
    "data_science.deactivate_schedule": "oci.data_science.DataScienceClient.deactivate_schedule",
    "data_science.delete_data_science_private_endpoint": "oci.data_science.DataScienceClient.delete_data_science_private_endpoint",
    "data_science.delete_job": "oci.data_science.DataScienceClient.delete_job",
    "data_science.delete_job_run": "oci.data_science.DataScienceClient.delete_job_run",
    "data_science.delete_ml_application": "oci.data_science.DataScienceClient.delete_ml_application",
    "data_science.delete_ml_application_implementation": "oci.data_science.DataScienceClient.delete_ml_application_implementation",
    "data_science.delete_ml_application_instance": "oci.data_science.DataScienceClient.delete_ml_application_instance",
    "data_science.delete_model": "oci.data_science.DataScienceClient.delete_model",
    "data_science.delete_model_custom_metadatum_artifact": "oci.data_science.DataScienceClient.delete_model_custom_metadatum_artifact",
    "data_science.delete_model_defined_metadatum_artifact": "oci.data_science.DataScienceClient.delete_model_defined_metadatum_artifact",
    "data_science.delete_model_deployment": "oci.data_science.DataScienceClient.delete_model_deployment",
    "data_science.delete_model_version_set": "oci.data_science.DataScienceClient.delete_model_version_set",
    "data_science.delete_notebook_session": "oci.data_science.DataScienceClient.delete_notebook_session",
    "data_science.delete_pipeline": "oci.data_science.DataScienceClient.delete_pipeline",
    "data_science.delete_pipeline_run": "oci.data_science.DataScienceClient.delete_pipeline_run",
    "data_science.delete_project": "oci.data_science.DataScienceClient.delete_project",
    "data_science.delete_schedule": "oci.data_science.DataScienceClient.delete_schedule",
    "data_science.disable_ml_application_instance_view_trigger": "oci.data_science.DataScienceClient.disable_ml_application_instance_view_trigger",
    "data_science.enable_ml_application_instance_view_trigger": "oci.data_science.DataScienceClient.enable_ml_application_instance_view_trigger",
    "data_science.export_model_artifact": "oci.data_science.DataScienceClient.export_model_artifact",
    "data_science.get_data_science_private_endpoint": "oci.data_science.DataScienceClient.get_data_science_private_endpoint",
    "data_science.get_job": "oci.data_science.DataScienceClient.get_job",
    "data_science.get_job_artifact_content": "oci.data_science.DataScienceClient.get_job_artifact_content",
    "data_science.get_job_run": "oci.data_science.DataScienceClient.get_job_run",
    "data_science.get_ml_application": "oci.data_science.DataScienceClient.get_ml_application",
    "data_science.get_ml_application_historical_package_content": "oci.data_science.DataScienceClient.get_ml_application_historical_package_content",
    "data_science.get_ml_application_implementation": "oci.data_science.DataScienceClient.get_ml_application_implementation",
    "data_science.get_ml_application_implementation_version": "oci.data_science.DataScienceClient.get_ml_application_implementation_version",
    "data_science.get_ml_application_instance": "oci.data_science.DataScienceClient.get_ml_application_instance",
    "data_science.get_ml_application_instance_view": "oci.data_science.DataScienceClient.get_ml_application_instance_view",
    "data_science.get_ml_application_package_content": "oci.data_science.DataScienceClient.get_ml_application_package_content",
    "data_science.get_model": "oci.data_science.DataScienceClient.get_model",
    "data_science.get_model_artifact_content": "oci.data_science.DataScienceClient.get_model_artifact_content",
    "data_science.get_model_custom_metadatum_artifact_content": "oci.data_science.DataScienceClient.get_model_custom_metadatum_artifact_content",
    "data_science.get_model_defined_metadatum_artifact_content": "oci.data_science.DataScienceClient.get_model_defined_metadatum_artifact_content",
    "data_science.get_model_deployment": "oci.data_science.DataScienceClient.get_model_deployment",
    "data_science.get_model_provenance": "oci.data_science.DataScienceClient.get_model_provenance",
    "data_science.get_model_version_set": "oci.data_science.DataScienceClient.get_model_version_set",
    "data_science.get_notebook_session": "oci.data_science.DataScienceClient.get_notebook_session",
    "data_science.get_pipeline": "oci.data_science.DataScienceClient.get_pipeline",
    "data_science.get_pipeline_run": "oci.data_science.DataScienceClient.get_pipeline_run",
    "data_science.get_project": "oci.data_science.DataScienceClient.get_project",
    "data_science.get_schedule": "oci.data_science.DataScienceClient.get_schedule",
    "data_science.get_step_artifact_content": "oci.data_science.DataScienceClient.get_step_artifact_content",
    "data_science.get_work_request": "oci.data_science.DataScienceClient.get_work_request",
    "data_science.head_job_artifact": "oci.data_science.DataScienceClient.head_job_artifact",
    "data_science.head_model_artifact": "oci.data_science.DataScienceClient.head_model_artifact",
    "data_science.head_model_custom_metadatum_artifact": "oci.data_science.DataScienceClient.head_model_custom_metadatum_artifact",
    "data_science.head_model_defined_metadatum_artifact": "oci.data_science.DataScienceClient.head_model_defined_metadatum_artifact",
    "data_science.head_step_artifact": "oci.data_science.DataScienceClient.head_step_artifact",
    "data_science.import_model_artifact": "oci.data_science.DataScienceClient.import_model_artifact",
    "data_science.list_containers": "oci.data_science.DataScienceClient.list_containers",
    "data_science.list_data_science_private_endpoints": "oci.data_science.DataScienceClient.list_data_science_private_endpoints",
    "data_science.list_fast_launch_job_configs": "oci.data_science.DataScienceClient.list_fast_launch_job_configs",
    "data_science.list_job_runs": "oci.data_science.DataScienceClient.list_job_runs",
    "data_science.list_job_shapes": "oci.data_science.DataScienceClient.list_job_shapes",
    "data_science.list_jobs": "oci.data_science.DataScienceClient.list_jobs",
    "data_science.list_ml_application_implementation_versions": "oci.data_science.DataScienceClient.list_ml_application_implementation_versions",
    "data_science.list_ml_application_implementations": "oci.data_science.DataScienceClient.list_ml_application_implementations",
    "data_science.list_ml_application_instance_views": "oci.data_science.DataScienceClient.list_ml_application_instance_views",
    "data_science.list_ml_application_instances": "oci.data_science.DataScienceClient.list_ml_application_instances",
    "data_science.list_ml_applications": "oci.data_science.DataScienceClient.list_ml_applications",
    "data_science.list_model_deployment_shapes": "oci.data_science.DataScienceClient.list_model_deployment_shapes",
    "data_science.list_model_deployments": "oci.data_science.DataScienceClient.list_model_deployments",
    "data_science.list_model_version_sets": "oci.data_science.DataScienceClient.list_model_version_sets",
    "data_science.list_models": "oci.data_science.DataScienceClient.list_models",
    "data_science.list_notebook_session_shapes": "oci.data_science.DataScienceClient.list_notebook_session_shapes",
    "data_science.list_notebook_sessions": "oci.data_science.DataScienceClient.list_notebook_sessions",
    "data_science.list_pipeline_runs": "oci.data_science.DataScienceClient.list_pipeline_runs",
    "data_science.list_pipelines": "oci.data_science.DataScienceClient.list_pipelines",
    "data_science.list_projects": "oci.data_science.DataScienceClient.list_projects",
    "data_science.list_schedules": "oci.data_science.DataScienceClient.list_schedules",
    "data_science.list_work_request_errors": "oci.data_science.DataScienceClient.list_work_request_errors",
    "data_science.list_work_request_logs": "oci.data_science.DataScienceClient.list_work_request_logs",
    "data_science.list_work_requests": "oci.data_science.DataScienceClient.list_work_requests",
    "data_science.put_ml_application_package": "oci.data_science.DataScienceClient.put_ml_application_package",
    "data_science.recover_ml_application_instance_view": "oci.data_science.DataScienceClient.recover_ml_application_instance_view",
    "data_science.register_model_artifact_reference": "oci.data_science.DataScienceClient.register_model_artifact_reference",
    "data_science.restore_archived_model_artifact": "oci.data_science.DataScienceClient.restore_archived_model_artifact",
    "data_science.trigger_ml_application_instance_flow": "oci.data_science.DataScienceClient.trigger_ml_application_instance_flow",
    "data_science.trigger_ml_application_instance_view_flow": "oci.data_science.DataScienceClient.trigger_ml_application_instance_view_flow",
    "data_science.update_data_science_private_endpoint": "oci.data_science.DataScienceClient.update_data_science_private_endpoint",
    "data_science.update_job": "oci.data_science.DataScienceClient.update_job",
    "data_science.update_job_run": "oci.data_science.DataScienceClient.update_job_run",
    "data_science.update_ml_application": "oci.data_science.DataScienceClient.update_ml_application",
    "data_science.update_ml_application_implementation": "oci.data_science.DataScienceClient.update_ml_application_implementation",
    "data_science.update_ml_application_implementation_version": "oci.data_science.DataScienceClient.update_ml_application_implementation_version",
    "data_science.update_ml_application_instance": "oci.data_science.DataScienceClient.update_ml_application_instance",
    "data_science.update_ml_application_instance_view": "oci.data_science.DataScienceClient.update_ml_application_instance_view",
    "data_science.update_model": "oci.data_science.DataScienceClient.update_model",
    "data_science.update_model_custom_metadatum_artifact": "oci.data_science.DataScienceClient.update_model_custom_metadatum_artifact",
    "data_science.update_model_defined_metadatum_artifact": "oci.data_science.DataScienceClient.update_model_defined_metadatum_artifact",
    "data_science.update_model_deployment": "oci.data_science.DataScienceClient.update_model_deployment",
    "data_science.update_model_provenance": "oci.data_science.DataScienceClient.update_model_provenance",
    "data_science.update_model_version_set": "oci.data_science.DataScienceClient.update_model_version_set",
    "data_science.update_notebook_session": "oci.data_science.DataScienceClient.update_notebook_session",
    "data_science.update_pipeline": "oci.data_science.DataScienceClient.update_pipeline",
    "data_science.update_pipeline_run": "oci.data_science.DataScienceClient.update_pipeline_run",
    "data_science.update_project": "oci.data_science.DataScienceClient.update_project",
    "data_science.update_schedule": "oci.data_science.DataScienceClient.update_schedule",
}
