# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates. All rights reserved.

SDK_client_map = {
    "db.activate_exadata_infrastructure": "oci.database.DatabaseClient.activate_exadata_infrastructure",
    "db.add_standby_autonomous_container_database": "oci.database.DatabaseClient.add_standby_autonomous_container_database",
    "db.add_storage_capacity_cloud_exadata_infrastructure": "oci.database.DatabaseClient.add_storage_capacity_cloud_exadata_infrastructure",
    "db.add_storage_capacity_exadata_infrastructure": "oci.database.DatabaseClient.add_storage_capacity_exadata_infrastructure",
    "db.add_virtual_machine_to_cloud_vm_cluster": "oci.database.DatabaseClient.add_virtual_machine_to_cloud_vm_cluster",
    "db.add_virtual_machine_to_vm_cluster": "oci.database.DatabaseClient.add_virtual_machine_to_vm_cluster",
    "db.autonomous_database_manual_refresh": "oci.database.DatabaseClient.autonomous_database_manual_refresh",
    "db.cancel_backup": "oci.database.DatabaseClient.cancel_backup",
    "db.cancel_execution_window": "oci.database.DatabaseClient.cancel_execution_window",
    "db.cascading_delete_scheduling_plan": "oci.database.DatabaseClient.cascading_delete_scheduling_plan",
    "db.change_autonomous_container_database_compartment": "oci.database.DatabaseClient.change_autonomous_container_database_compartment",
    "db.change_autonomous_database_compartment": "oci.database.DatabaseClient.change_autonomous_database_compartment",
    "db.change_autonomous_database_software_image_compartment": "oci.database.DatabaseClient.change_autonomous_database_software_image_compartment",
    "db.change_autonomous_database_subscription": "oci.database.DatabaseClient.change_autonomous_database_subscription",
    "db.change_autonomous_exadata_infrastructure_compartment": "oci.database.DatabaseClient.change_autonomous_exadata_infrastructure_compartment",
    "db.change_autonomous_vm_cluster_compartment": "oci.database.DatabaseClient.change_autonomous_vm_cluster_compartment",
    "db.change_backup_destination_compartment": "oci.database.DatabaseClient.change_backup_destination_compartment",
    "db.change_cloud_autonomous_vm_cluster_compartment": "oci.database.DatabaseClient.change_cloud_autonomous_vm_cluster_compartment",
    "db.change_cloud_autonomous_vm_cluster_subscription": "oci.database.DatabaseClient.change_cloud_autonomous_vm_cluster_subscription",
    "db.change_cloud_exadata_infrastructure_compartment": "oci.database.DatabaseClient.change_cloud_exadata_infrastructure_compartment",
    "db.change_cloud_exadata_infrastructure_subscription": "oci.database.DatabaseClient.change_cloud_exadata_infrastructure_subscription",
    "db.change_cloud_vm_cluster_compartment": "oci.database.DatabaseClient.change_cloud_vm_cluster_compartment",
    "db.change_cloud_vm_cluster_subscription": "oci.database.DatabaseClient.change_cloud_vm_cluster_subscription",
    "db.change_database_software_image_compartment": "oci.database.DatabaseClient.change_database_software_image_compartment",
    "db.change_dataguard_role": "oci.database.DatabaseClient.change_dataguard_role",
    "db.change_db_system_compartment": "oci.database.DatabaseClient.change_db_system_compartment",
    "db.change_disaster_recovery_configuration": "oci.database.DatabaseClient.change_disaster_recovery_configuration",
    "db.change_encryption_key_location": "oci.database.DatabaseClient.change_encryption_key_location",
    "db.change_exadata_infrastructure_compartment": "oci.database.DatabaseClient.change_exadata_infrastructure_compartment",
    "db.change_exadb_vm_cluster_compartment": "oci.database.DatabaseClient.change_exadb_vm_cluster_compartment",
    "db.change_exadb_vm_cluster_subscription": "oci.database.DatabaseClient.change_exadb_vm_cluster_subscription",
    "db.change_exascale_db_storage_vault_compartment": "oci.database.DatabaseClient.change_exascale_db_storage_vault_compartment",
    "db.change_exascale_db_storage_vault_subscription": "oci.database.DatabaseClient.change_exascale_db_storage_vault_subscription",
    "db.change_external_container_database_compartment": "oci.database.DatabaseClient.change_external_container_database_compartment",
    "db.change_external_non_container_database_compartment": "oci.database.DatabaseClient.change_external_non_container_database_compartment",
    "db.change_external_pluggable_database_compartment": "oci.database.DatabaseClient.change_external_pluggable_database_compartment",
    "db.change_key_store_compartment": "oci.database.DatabaseClient.change_key_store_compartment",
    "db.change_key_store_type": "oci.database.DatabaseClient.change_key_store_type",
    "db.change_oneoff_patch_compartment": "oci.database.DatabaseClient.change_oneoff_patch_compartment",
    "db.change_scheduling_plan_compartment": "oci.database.DatabaseClient.change_scheduling_plan_compartment",
    "db.change_scheduling_policy_compartment": "oci.database.DatabaseClient.change_scheduling_policy_compartment",
    "db.change_vm_cluster_compartment": "oci.database.DatabaseClient.change_vm_cluster_compartment",
    "db.check_external_database_connector_connection_status": "oci.database.DatabaseClient.check_external_database_connector_connection_status",
    "db.complete_external_backup_job": "oci.database.DatabaseClient.complete_external_backup_job",
    "db.configure_autonomous_database_vault_key": "oci.database.DatabaseClient.configure_autonomous_database_vault_key",
    "db.configure_exascale_exadata_infrastructure": "oci.database.DatabaseClient.configure_exascale_exadata_infrastructure",
    "db.configure_saas_admin_user": "oci.database.DatabaseClient.configure_saas_admin_user",
    "db.confirm_key_store_details_are_correct": "oci.database.DatabaseClient.confirm_key_store_details_are_correct",
    "db.convert_standby_autonomous_container_database": "oci.database.DatabaseClient.convert_standby_autonomous_container_database",
    "db.convert_to_pdb": "oci.database.DatabaseClient.convert_to_pdb",
    "db.convert_to_regular_pluggable_database": "oci.database.DatabaseClient.convert_to_regular_pluggable_database",
    "db.convert_to_standalone": "oci.database.DatabaseClient.convert_to_standalone",
    "db.create_application_vip": "oci.database.DatabaseClient.create_application_vip",
    "db.create_autonomous_container_database": "oci.database.DatabaseClient.create_autonomous_container_database",
    "db.create_autonomous_container_database_dataguard_association": "oci.database.DatabaseClient.create_autonomous_container_database_dataguard_association",
    "db.create_autonomous_database": "oci.database.DatabaseClient.create_autonomous_database",
    "db.create_autonomous_database_backup": "oci.database.DatabaseClient.create_autonomous_database_backup",
    "db.create_autonomous_database_software_image": "oci.database.DatabaseClient.create_autonomous_database_software_image",
    "db.create_autonomous_vm_cluster": "oci.database.DatabaseClient.create_autonomous_vm_cluster",
    "db.create_backup": "oci.database.DatabaseClient.create_backup",
    "db.create_backup_destination": "oci.database.DatabaseClient.create_backup_destination",
    "db.create_cloud_autonomous_vm_cluster": "oci.database.DatabaseClient.create_cloud_autonomous_vm_cluster",
    "db.create_cloud_exadata_infrastructure": "oci.database.DatabaseClient.create_cloud_exadata_infrastructure",
    "db.create_cloud_vm_cluster": "oci.database.DatabaseClient.create_cloud_vm_cluster",
    "db.create_console_connection": "oci.database.DatabaseClient.create_console_connection",
    "db.create_console_history": "oci.database.DatabaseClient.create_console_history",
    "db.create_data_guard_association": "oci.database.DatabaseClient.create_data_guard_association",
    "db.create_database": "oci.database.DatabaseClient.create_database",
    "db.create_database_software_image": "oci.database.DatabaseClient.create_database_software_image",
    "db.create_db_home": "oci.database.DatabaseClient.create_db_home",
    "db.create_exadata_infrastructure": "oci.database.DatabaseClient.create_exadata_infrastructure",
    "db.create_exadb_vm_cluster": "oci.database.DatabaseClient.create_exadb_vm_cluster",
    "db.create_exascale_db_storage_vault": "oci.database.DatabaseClient.create_exascale_db_storage_vault",
    "db.create_execution_action": "oci.database.DatabaseClient.create_execution_action",
    "db.create_execution_window": "oci.database.DatabaseClient.create_execution_window",
    "db.create_external_backup_job": "oci.database.DatabaseClient.create_external_backup_job",
    "db.create_external_container_database": "oci.database.DatabaseClient.create_external_container_database",
    "db.create_external_database_connector": "oci.database.DatabaseClient.create_external_database_connector",
    "db.create_external_non_container_database": "oci.database.DatabaseClient.create_external_non_container_database",
    "db.create_external_pluggable_database": "oci.database.DatabaseClient.create_external_pluggable_database",
    "db.create_key_store": "oci.database.DatabaseClient.create_key_store",
    "db.create_maintenance_run": "oci.database.DatabaseClient.create_maintenance_run",
    "db.create_oneoff_patch": "oci.database.DatabaseClient.create_oneoff_patch",
    "db.create_pluggable_database": "oci.database.DatabaseClient.create_pluggable_database",
    "db.create_scheduled_action": "oci.database.DatabaseClient.create_scheduled_action",
    "db.create_scheduling_plan": "oci.database.DatabaseClient.create_scheduling_plan",
    "db.create_scheduling_policy": "oci.database.DatabaseClient.create_scheduling_policy",
    "db.create_scheduling_window": "oci.database.DatabaseClient.create_scheduling_window",
    "db.create_vm_cluster": "oci.database.DatabaseClient.create_vm_cluster",
    "db.create_vm_cluster_network": "oci.database.DatabaseClient.create_vm_cluster_network",
    "db.db_node_action": "oci.database.DatabaseClient.db_node_action",
    "db.delete_application_vip": "oci.database.DatabaseClient.delete_application_vip",
    "db.delete_autonomous_database": "oci.database.DatabaseClient.delete_autonomous_database",
    "db.delete_autonomous_database_backup": "oci.database.DatabaseClient.delete_autonomous_database_backup",
    "db.delete_autonomous_database_software_image": "oci.database.DatabaseClient.delete_autonomous_database_software_image",
    "db.delete_autonomous_vm_cluster": "oci.database.DatabaseClient.delete_autonomous_vm_cluster",
    "db.delete_backup": "oci.database.DatabaseClient.delete_backup",
    "db.delete_backup_destination": "oci.database.DatabaseClient.delete_backup_destination",
    "db.delete_cloud_autonomous_vm_cluster": "oci.database.DatabaseClient.delete_cloud_autonomous_vm_cluster",
    "db.delete_cloud_exadata_infrastructure": "oci.database.DatabaseClient.delete_cloud_exadata_infrastructure",
    "db.delete_cloud_vm_cluster": "oci.database.DatabaseClient.delete_cloud_vm_cluster",
    "db.delete_console_connection": "oci.database.DatabaseClient.delete_console_connection",
    "db.delete_console_history": "oci.database.DatabaseClient.delete_console_history",
    "db.delete_database": "oci.database.DatabaseClient.delete_database",
    "db.delete_database_software_image": "oci.database.DatabaseClient.delete_database_software_image",
    "db.delete_db_home": "oci.database.DatabaseClient.delete_db_home",
    "db.delete_exadata_infrastructure": "oci.database.DatabaseClient.delete_exadata_infrastructure",
    "db.delete_exadb_vm_cluster": "oci.database.DatabaseClient.delete_exadb_vm_cluster",
    "db.delete_exascale_db_storage_vault": "oci.database.DatabaseClient.delete_exascale_db_storage_vault",
    "db.delete_execution_action": "oci.database.DatabaseClient.delete_execution_action",
    "db.delete_execution_window": "oci.database.DatabaseClient.delete_execution_window",
    "db.delete_external_container_database": "oci.database.DatabaseClient.delete_external_container_database",
    "db.delete_external_database_connector": "oci.database.DatabaseClient.delete_external_database_connector",
    "db.delete_external_non_container_database": "oci.database.DatabaseClient.delete_external_non_container_database",
    "db.delete_external_pluggable_database": "oci.database.DatabaseClient.delete_external_pluggable_database",
    "db.delete_key_store": "oci.database.DatabaseClient.delete_key_store",
    "db.delete_oneoff_patch": "oci.database.DatabaseClient.delete_oneoff_patch",
    "db.delete_pluggable_database": "oci.database.DatabaseClient.delete_pluggable_database",
    "db.delete_scheduled_action": "oci.database.DatabaseClient.delete_scheduled_action",
    "db.delete_scheduling_plan": "oci.database.DatabaseClient.delete_scheduling_plan",
    "db.delete_scheduling_policy": "oci.database.DatabaseClient.delete_scheduling_policy",
    "db.delete_scheduling_window": "oci.database.DatabaseClient.delete_scheduling_window",
    "db.delete_vm_cluster": "oci.database.DatabaseClient.delete_vm_cluster",
    "db.delete_vm_cluster_network": "oci.database.DatabaseClient.delete_vm_cluster_network",
    "db.deregister_autonomous_database_data_safe": "oci.database.DatabaseClient.deregister_autonomous_database_data_safe",
    "db.disable_autonomous_database_management": "oci.database.DatabaseClient.disable_autonomous_database_management",
    "db.disable_autonomous_database_operations_insights": "oci.database.DatabaseClient.disable_autonomous_database_operations_insights",
    "db.disable_database_management": "oci.database.DatabaseClient.disable_database_management",
    "db.disable_external_container_database_database_management": "oci.database.DatabaseClient.disable_external_container_database_database_management",
    "db.disable_external_container_database_stack_monitoring": "oci.database.DatabaseClient.disable_external_container_database_stack_monitoring",
    "db.disable_external_non_container_database_database_management": "oci.database.DatabaseClient.disable_external_non_container_database_database_management",
    "db.disable_external_non_container_database_operations_insights": "oci.database.DatabaseClient.disable_external_non_container_database_operations_insights",
    "db.disable_external_non_container_database_stack_monitoring": "oci.database.DatabaseClient.disable_external_non_container_database_stack_monitoring",
    "db.disable_external_pluggable_database_database_management": "oci.database.DatabaseClient.disable_external_pluggable_database_database_management",
    "db.disable_external_pluggable_database_operations_insights": "oci.database.DatabaseClient.disable_external_pluggable_database_operations_insights",
    "db.disable_external_pluggable_database_stack_monitoring": "oci.database.DatabaseClient.disable_external_pluggable_database_stack_monitoring",
    "db.disable_pluggable_database_management": "oci.database.DatabaseClient.disable_pluggable_database_management",
    "db.download_exadata_infrastructure_config_file": "oci.database.DatabaseClient.download_exadata_infrastructure_config_file",
    "db.download_oneoff_patch": "oci.database.DatabaseClient.download_oneoff_patch",
    "db.download_validation_report": "oci.database.DatabaseClient.download_validation_report",
    "db.download_vm_cluster_network_config_file": "oci.database.DatabaseClient.download_vm_cluster_network_config_file",
    "db.edit_autonomous_container_database_dataguard": "oci.database.DatabaseClient.edit_autonomous_container_database_dataguard",
    "db.enable_autonomous_database_management": "oci.database.DatabaseClient.enable_autonomous_database_management",
    "db.enable_autonomous_database_operations_insights": "oci.database.DatabaseClient.enable_autonomous_database_operations_insights",
    "db.enable_database_management": "oci.database.DatabaseClient.enable_database_management",
    "db.enable_external_container_database_database_management": "oci.database.DatabaseClient.enable_external_container_database_database_management",
    "db.enable_external_container_database_stack_monitoring": "oci.database.DatabaseClient.enable_external_container_database_stack_monitoring",
    "db.enable_external_non_container_database_database_management": "oci.database.DatabaseClient.enable_external_non_container_database_database_management",
    "db.enable_external_non_container_database_operations_insights": "oci.database.DatabaseClient.enable_external_non_container_database_operations_insights",
    "db.enable_external_non_container_database_stack_monitoring": "oci.database.DatabaseClient.enable_external_non_container_database_stack_monitoring",
    "db.enable_external_pluggable_database_database_management": "oci.database.DatabaseClient.enable_external_pluggable_database_database_management",
    "db.enable_external_pluggable_database_operations_insights": "oci.database.DatabaseClient.enable_external_pluggable_database_operations_insights",
    "db.enable_external_pluggable_database_stack_monitoring": "oci.database.DatabaseClient.enable_external_pluggable_database_stack_monitoring",
    "db.enable_pluggable_database_management": "oci.database.DatabaseClient.enable_pluggable_database_management",
    "db.fail_over_autonomous_database": "oci.database.DatabaseClient.fail_over_autonomous_database",
    "db.failover_autonomous_container_database_dataguard": "oci.database.DatabaseClient.failover_autonomous_container_database_dataguard",
    "db.failover_autonomous_container_database_dataguard_association": "oci.database.DatabaseClient.failover_autonomous_container_database_dataguard_association",
    "db.failover_data_guard": "oci.database.DatabaseClient.failover_data_guard",
    "db.failover_data_guard_association": "oci.database.DatabaseClient.failover_data_guard_association",
    "db.generate_autonomous_database_wallet": "oci.database.DatabaseClient.generate_autonomous_database_wallet",
    "db.generate_recommended_vm_cluster_network": "oci.database.DatabaseClient.generate_recommended_vm_cluster_network",
    "db.get_application_vip": "oci.database.DatabaseClient.get_application_vip",
    "db.get_autonomous_container_database": "oci.database.DatabaseClient.get_autonomous_container_database",
    "db.get_autonomous_container_database_dataguard_association": "oci.database.DatabaseClient.get_autonomous_container_database_dataguard_association",
    "db.get_autonomous_container_database_resource_usage": "oci.database.DatabaseClient.get_autonomous_container_database_resource_usage",
    "db.get_autonomous_database": "oci.database.DatabaseClient.get_autonomous_database",
    "db.get_autonomous_database_backup": "oci.database.DatabaseClient.get_autonomous_database_backup",
    "db.get_autonomous_database_dataguard_association": "oci.database.DatabaseClient.get_autonomous_database_dataguard_association",
    "db.get_autonomous_database_regional_wallet": "oci.database.DatabaseClient.get_autonomous_database_regional_wallet",
    "db.get_autonomous_database_software_image": "oci.database.DatabaseClient.get_autonomous_database_software_image",
    "db.get_autonomous_database_wallet": "oci.database.DatabaseClient.get_autonomous_database_wallet",
    "db.get_autonomous_exadata_infrastructure": "oci.database.DatabaseClient.get_autonomous_exadata_infrastructure",
    "db.get_autonomous_patch": "oci.database.DatabaseClient.get_autonomous_patch",
    "db.get_autonomous_virtual_machine": "oci.database.DatabaseClient.get_autonomous_virtual_machine",
    "db.get_autonomous_vm_cluster": "oci.database.DatabaseClient.get_autonomous_vm_cluster",
    "db.get_autonomous_vm_cluster_resource_usage": "oci.database.DatabaseClient.get_autonomous_vm_cluster_resource_usage",
    "db.get_backup": "oci.database.DatabaseClient.get_backup",
    "db.get_backup_destination": "oci.database.DatabaseClient.get_backup_destination",
    "db.get_cloud_autonomous_vm_cluster": "oci.database.DatabaseClient.get_cloud_autonomous_vm_cluster",
    "db.get_cloud_autonomous_vm_cluster_resource_usage": "oci.database.DatabaseClient.get_cloud_autonomous_vm_cluster_resource_usage",
    "db.get_cloud_exadata_infrastructure": "oci.database.DatabaseClient.get_cloud_exadata_infrastructure",
    "db.get_cloud_exadata_infrastructure_unallocated_resources": "oci.database.DatabaseClient.get_cloud_exadata_infrastructure_unallocated_resources",
    "db.get_cloud_vm_cluster": "oci.database.DatabaseClient.get_cloud_vm_cluster",
    "db.get_cloud_vm_cluster_iorm_config": "oci.database.DatabaseClient.get_cloud_vm_cluster_iorm_config",
    "db.get_cloud_vm_cluster_update": "oci.database.DatabaseClient.get_cloud_vm_cluster_update",
    "db.get_cloud_vm_cluster_update_history_entry": "oci.database.DatabaseClient.get_cloud_vm_cluster_update_history_entry",
    "db.get_console_connection": "oci.database.DatabaseClient.get_console_connection",
    "db.get_console_history": "oci.database.DatabaseClient.get_console_history",
    "db.get_console_history_content": "oci.database.DatabaseClient.get_console_history_content",
    "db.get_data_guard_association": "oci.database.DatabaseClient.get_data_guard_association",
    "db.get_database": "oci.database.DatabaseClient.get_database",
    "db.get_database_software_image": "oci.database.DatabaseClient.get_database_software_image",
    "db.get_database_upgrade_history_entry": "oci.database.DatabaseClient.get_database_upgrade_history_entry",
    "db.get_db_home": "oci.database.DatabaseClient.get_db_home",
    "db.get_db_home_patch": "oci.database.DatabaseClient.get_db_home_patch",
    "db.get_db_home_patch_history_entry": "oci.database.DatabaseClient.get_db_home_patch_history_entry",
    "db.get_db_node": "oci.database.DatabaseClient.get_db_node",
    "db.get_db_server": "oci.database.DatabaseClient.get_db_server",
    "db.get_db_system": "oci.database.DatabaseClient.get_db_system",
    "db.get_db_system_patch": "oci.database.DatabaseClient.get_db_system_patch",
    "db.get_db_system_patch_history_entry": "oci.database.DatabaseClient.get_db_system_patch_history_entry",
    "db.get_db_system_upgrade_history_entry": "oci.database.DatabaseClient.get_db_system_upgrade_history_entry",
    "db.get_exadata_infrastructure": "oci.database.DatabaseClient.get_exadata_infrastructure",
    "db.get_exadata_infrastructure_ocpus": "oci.database.DatabaseClient.get_exadata_infrastructure_ocpus",
    "db.get_exadata_infrastructure_un_allocated_resources": "oci.database.DatabaseClient.get_exadata_infrastructure_un_allocated_resources",
    "db.get_exadata_iorm_config": "oci.database.DatabaseClient.get_exadata_iorm_config",
    "db.get_exadb_vm_cluster": "oci.database.DatabaseClient.get_exadb_vm_cluster",
    "db.get_exadb_vm_cluster_update": "oci.database.DatabaseClient.get_exadb_vm_cluster_update",
    "db.get_exadb_vm_cluster_update_history_entry": "oci.database.DatabaseClient.get_exadb_vm_cluster_update_history_entry",
    "db.get_exascale_db_storage_vault": "oci.database.DatabaseClient.get_exascale_db_storage_vault",
    "db.get_execution_action": "oci.database.DatabaseClient.get_execution_action",
    "db.get_execution_window": "oci.database.DatabaseClient.get_execution_window",
    "db.get_external_backup_job": "oci.database.DatabaseClient.get_external_backup_job",
    "db.get_external_container_database": "oci.database.DatabaseClient.get_external_container_database",
    "db.get_external_database_connector": "oci.database.DatabaseClient.get_external_database_connector",
    "db.get_external_non_container_database": "oci.database.DatabaseClient.get_external_non_container_database",
    "db.get_external_pluggable_database": "oci.database.DatabaseClient.get_external_pluggable_database",
    "db.get_infrastructure_target_versions": "oci.database.DatabaseClient.get_infrastructure_target_versions",
    "db.get_key_store": "oci.database.DatabaseClient.get_key_store",
    "db.get_maintenance_run": "oci.database.DatabaseClient.get_maintenance_run",
    "db.get_maintenance_run_history": "oci.database.DatabaseClient.get_maintenance_run_history",
    "db.get_oneoff_patch": "oci.database.DatabaseClient.get_oneoff_patch",
    "db.get_pdb_conversion_history_entry": "oci.database.DatabaseClient.get_pdb_conversion_history_entry",
    "db.get_pluggable_database": "oci.database.DatabaseClient.get_pluggable_database",
    "db.get_scheduled_action": "oci.database.DatabaseClient.get_scheduled_action",
    "db.get_scheduling_plan": "oci.database.DatabaseClient.get_scheduling_plan",
    "db.get_scheduling_policy": "oci.database.DatabaseClient.get_scheduling_policy",
    "db.get_scheduling_window": "oci.database.DatabaseClient.get_scheduling_window",
    "db.get_vm_cluster": "oci.database.DatabaseClient.get_vm_cluster",
    "db.get_vm_cluster_network": "oci.database.DatabaseClient.get_vm_cluster_network",
    "db.get_vm_cluster_patch": "oci.database.DatabaseClient.get_vm_cluster_patch",
    "db.get_vm_cluster_patch_history_entry": "oci.database.DatabaseClient.get_vm_cluster_patch_history_entry",
    "db.get_vm_cluster_update": "oci.database.DatabaseClient.get_vm_cluster_update",
    "db.get_vm_cluster_update_history_entry": "oci.database.DatabaseClient.get_vm_cluster_update_history_entry",
    "db.launch_autonomous_exadata_infrastructure": "oci.database.DatabaseClient.launch_autonomous_exadata_infrastructure",
    "db.launch_db_system": "oci.database.DatabaseClient.launch_db_system",
    "db.list_application_vips": "oci.database.DatabaseClient.list_application_vips",
    "db.list_autonomous_container_database_backups": "oci.database.DatabaseClient.list_autonomous_container_database_backups",
    "db.list_autonomous_container_database_dataguard_associations": "oci.database.DatabaseClient.list_autonomous_container_database_dataguard_associations",
    "db.list_autonomous_container_database_versions": "oci.database.DatabaseClient.list_autonomous_container_database_versions",
    "db.list_autonomous_container_databases": "oci.database.DatabaseClient.list_autonomous_container_databases",
    "db.list_autonomous_database_backups": "oci.database.DatabaseClient.list_autonomous_database_backups",
    "db.list_autonomous_database_character_sets": "oci.database.DatabaseClient.list_autonomous_database_character_sets",
    "db.list_autonomous_database_clones": "oci.database.DatabaseClient.list_autonomous_database_clones",
    "db.list_autonomous_database_dataguard_associations": "oci.database.DatabaseClient.list_autonomous_database_dataguard_associations",
    "db.list_autonomous_database_peers": "oci.database.DatabaseClient.list_autonomous_database_peers",
    "db.list_autonomous_database_refreshable_clones": "oci.database.DatabaseClient.list_autonomous_database_refreshable_clones",
    "db.list_autonomous_database_software_images": "oci.database.DatabaseClient.list_autonomous_database_software_images",
    "db.list_autonomous_databases": "oci.database.DatabaseClient.list_autonomous_databases",
    "db.list_autonomous_db_preview_versions": "oci.database.DatabaseClient.list_autonomous_db_preview_versions",
    "db.list_autonomous_db_versions": "oci.database.DatabaseClient.list_autonomous_db_versions",
    "db.list_autonomous_exadata_infrastructure_shapes": "oci.database.DatabaseClient.list_autonomous_exadata_infrastructure_shapes",
    "db.list_autonomous_exadata_infrastructures": "oci.database.DatabaseClient.list_autonomous_exadata_infrastructures",
    "db.list_autonomous_virtual_machines": "oci.database.DatabaseClient.list_autonomous_virtual_machines",
    "db.list_autonomous_vm_cluster_acd_resource_usage": "oci.database.DatabaseClient.list_autonomous_vm_cluster_acd_resource_usage",
    "db.list_autonomous_vm_clusters": "oci.database.DatabaseClient.list_autonomous_vm_clusters",
    "db.list_backup_destination": "oci.database.DatabaseClient.list_backup_destination",
    "db.list_backups": "oci.database.DatabaseClient.list_backups",
    "db.list_cloud_autonomous_vm_cluster_acd_resource_usage": "oci.database.DatabaseClient.list_cloud_autonomous_vm_cluster_acd_resource_usage",
    "db.list_cloud_autonomous_vm_clusters": "oci.database.DatabaseClient.list_cloud_autonomous_vm_clusters",
    "db.list_cloud_exadata_infrastructures": "oci.database.DatabaseClient.list_cloud_exadata_infrastructures",
    "db.list_cloud_vm_cluster_update_history_entries": "oci.database.DatabaseClient.list_cloud_vm_cluster_update_history_entries",
    "db.list_cloud_vm_cluster_updates": "oci.database.DatabaseClient.list_cloud_vm_cluster_updates",
    "db.list_cloud_vm_clusters": "oci.database.DatabaseClient.list_cloud_vm_clusters",
    "db.list_console_connections": "oci.database.DatabaseClient.list_console_connections",
    "db.list_console_histories": "oci.database.DatabaseClient.list_console_histories",
    "db.list_container_database_patches": "oci.database.DatabaseClient.list_container_database_patches",
    "db.list_data_guard_associations": "oci.database.DatabaseClient.list_data_guard_associations",
    "db.list_database_software_images": "oci.database.DatabaseClient.list_database_software_images",
    "db.list_database_upgrade_history_entries": "oci.database.DatabaseClient.list_database_upgrade_history_entries",
    "db.list_databases": "oci.database.DatabaseClient.list_databases",
    "db.list_db_home_patch_history_entries": "oci.database.DatabaseClient.list_db_home_patch_history_entries",
    "db.list_db_home_patches": "oci.database.DatabaseClient.list_db_home_patches",
    "db.list_db_homes": "oci.database.DatabaseClient.list_db_homes",
    "db.list_db_nodes": "oci.database.DatabaseClient.list_db_nodes",
    "db.list_db_servers": "oci.database.DatabaseClient.list_db_servers",
    "db.list_db_system_compute_performances": "oci.database.DatabaseClient.list_db_system_compute_performances",
    "db.list_db_system_patch_history_entries": "oci.database.DatabaseClient.list_db_system_patch_history_entries",
    "db.list_db_system_patches": "oci.database.DatabaseClient.list_db_system_patches",
    "db.list_db_system_shapes": "oci.database.DatabaseClient.list_db_system_shapes",
    "db.list_db_system_storage_performances": "oci.database.DatabaseClient.list_db_system_storage_performances",
    "db.list_db_system_upgrade_history_entries": "oci.database.DatabaseClient.list_db_system_upgrade_history_entries",
    "db.list_db_system_upgrades": "oci.database.DatabaseClient.list_db_system_upgrades",
    "db.list_db_systems": "oci.database.DatabaseClient.list_db_systems",
    "db.list_db_versions": "oci.database.DatabaseClient.list_db_versions",
    "db.list_exadata_infrastructures": "oci.database.DatabaseClient.list_exadata_infrastructures",
    "db.list_exadb_vm_cluster_update_history_entries": "oci.database.DatabaseClient.list_exadb_vm_cluster_update_history_entries",
    "db.list_exadb_vm_cluster_updates": "oci.database.DatabaseClient.list_exadb_vm_cluster_updates",
    "db.list_exadb_vm_clusters": "oci.database.DatabaseClient.list_exadb_vm_clusters",
    "db.list_exascale_db_storage_vaults": "oci.database.DatabaseClient.list_exascale_db_storage_vaults",
    "db.list_execution_actions": "oci.database.DatabaseClient.list_execution_actions",
    "db.list_execution_windows": "oci.database.DatabaseClient.list_execution_windows",
    "db.list_external_container_databases": "oci.database.DatabaseClient.list_external_container_databases",
    "db.list_external_database_connectors": "oci.database.DatabaseClient.list_external_database_connectors",
    "db.list_external_non_container_databases": "oci.database.DatabaseClient.list_external_non_container_databases",
    "db.list_external_pluggable_databases": "oci.database.DatabaseClient.list_external_pluggable_databases",
    "db.list_flex_components": "oci.database.DatabaseClient.list_flex_components",
    "db.list_gi_version_minor_versions": "oci.database.DatabaseClient.list_gi_version_minor_versions",
    "db.list_gi_versions": "oci.database.DatabaseClient.list_gi_versions",
    "db.list_key_stores": "oci.database.DatabaseClient.list_key_stores",
    "db.list_maintenance_run_history": "oci.database.DatabaseClient.list_maintenance_run_history",
    "db.list_maintenance_runs": "oci.database.DatabaseClient.list_maintenance_runs",
    "db.list_oneoff_patches": "oci.database.DatabaseClient.list_oneoff_patches",
    "db.list_params_for_action_type": "oci.database.DatabaseClient.list_params_for_action_type",
    "db.list_pdb_conversion_history_entries": "oci.database.DatabaseClient.list_pdb_conversion_history_entries",
    "db.list_pluggable_databases": "oci.database.DatabaseClient.list_pluggable_databases",
    "db.list_recommended_scheduled_actions": "oci.database.DatabaseClient.list_recommended_scheduled_actions",
    "db.list_resource_pool_members": "oci.database.DatabaseClient.list_resource_pool_members",
    "db.list_scheduled_actions": "oci.database.DatabaseClient.list_scheduled_actions",
    "db.list_scheduling_plans": "oci.database.DatabaseClient.list_scheduling_plans",
    "db.list_scheduling_policies": "oci.database.DatabaseClient.list_scheduling_policies",
    "db.list_scheduling_windows": "oci.database.DatabaseClient.list_scheduling_windows",
    "db.list_system_version_minor_versions": "oci.database.DatabaseClient.list_system_version_minor_versions",
    "db.list_system_versions": "oci.database.DatabaseClient.list_system_versions",
    "db.list_vm_cluster_networks": "oci.database.DatabaseClient.list_vm_cluster_networks",
    "db.list_vm_cluster_patch_history_entries": "oci.database.DatabaseClient.list_vm_cluster_patch_history_entries",
    "db.list_vm_cluster_patches": "oci.database.DatabaseClient.list_vm_cluster_patches",
    "db.list_vm_cluster_update_history_entries": "oci.database.DatabaseClient.list_vm_cluster_update_history_entries",
    "db.list_vm_cluster_updates": "oci.database.DatabaseClient.list_vm_cluster_updates",
    "db.list_vm_clusters": "oci.database.DatabaseClient.list_vm_clusters",
    "db.local_clone_pluggable_database": "oci.database.DatabaseClient.local_clone_pluggable_database",
    "db.migrate_autonomous_container_database_dataguard_association": "oci.database.DatabaseClient.migrate_autonomous_container_database_dataguard_association",
    "db.migrate_data_guard_association_to_multi_data_guards": "oci.database.DatabaseClient.migrate_data_guard_association_to_multi_data_guards",
    "db.migrate_exadata_db_system_resource_model": "oci.database.DatabaseClient.migrate_exadata_db_system_resource_model",
    "db.migrate_vault_key": "oci.database.DatabaseClient.migrate_vault_key",
    "db.modify_database_management": "oci.database.DatabaseClient.modify_database_management",
    "db.modify_pluggable_database_management": "oci.database.DatabaseClient.modify_pluggable_database_management",
    "db.move_execution_action_member": "oci.database.DatabaseClient.move_execution_action_member",
    "db.refresh_pluggable_database": "oci.database.DatabaseClient.refresh_pluggable_database",
    "db.register_autonomous_database_data_safe": "oci.database.DatabaseClient.register_autonomous_database_data_safe",
    "db.register_cloud_vm_cluster_pkcs": "oci.database.DatabaseClient.register_cloud_vm_cluster_pkcs",
    "db.reinstate_autonomous_container_database_dataguard": "oci.database.DatabaseClient.reinstate_autonomous_container_database_dataguard",
    "db.reinstate_autonomous_container_database_dataguard_association": "oci.database.DatabaseClient.reinstate_autonomous_container_database_dataguard_association",
    "db.reinstate_data_guard": "oci.database.DatabaseClient.reinstate_data_guard",
    "db.reinstate_data_guard_association": "oci.database.DatabaseClient.reinstate_data_guard_association",
    "db.remote_clone_pluggable_database": "oci.database.DatabaseClient.remote_clone_pluggable_database",
    "db.remove_virtual_machine_from_cloud_vm_cluster": "oci.database.DatabaseClient.remove_virtual_machine_from_cloud_vm_cluster",
    "db.remove_virtual_machine_from_exadb_vm_cluster": "oci.database.DatabaseClient.remove_virtual_machine_from_exadb_vm_cluster",
    "db.remove_virtual_machine_from_vm_cluster": "oci.database.DatabaseClient.remove_virtual_machine_from_vm_cluster",
    "db.reorder_execution_actions": "oci.database.DatabaseClient.reorder_execution_actions",
    "db.reorder_scheduled_actions": "oci.database.DatabaseClient.reorder_scheduled_actions",
    "db.resize_vm_cluster_network": "oci.database.DatabaseClient.resize_vm_cluster_network",
    "db.resource_pool_shapes": "oci.database.DatabaseClient.resource_pool_shapes",
    "db.restart_autonomous_container_database": "oci.database.DatabaseClient.restart_autonomous_container_database",
    "db.restart_autonomous_database": "oci.database.DatabaseClient.restart_autonomous_database",
    "db.restore_autonomous_database": "oci.database.DatabaseClient.restore_autonomous_database",
    "db.restore_database": "oci.database.DatabaseClient.restore_database",
    "db.rotate_autonomous_container_database_encryption_key": "oci.database.DatabaseClient.rotate_autonomous_container_database_encryption_key",
    "db.rotate_autonomous_database_encryption_key": "oci.database.DatabaseClient.rotate_autonomous_database_encryption_key",
    "db.rotate_autonomous_vm_cluster_ords_certs": "oci.database.DatabaseClient.rotate_autonomous_vm_cluster_ords_certs",
    "db.rotate_autonomous_vm_cluster_ssl_certs": "oci.database.DatabaseClient.rotate_autonomous_vm_cluster_ssl_certs",
    "db.rotate_cloud_autonomous_vm_cluster_ords_certs": "oci.database.DatabaseClient.rotate_cloud_autonomous_vm_cluster_ords_certs",
    "db.rotate_cloud_autonomous_vm_cluster_ssl_certs": "oci.database.DatabaseClient.rotate_cloud_autonomous_vm_cluster_ssl_certs",
    "db.rotate_ords_certs": "oci.database.DatabaseClient.rotate_ords_certs",
    "db.rotate_pluggable_database_encryption_key": "oci.database.DatabaseClient.rotate_pluggable_database_encryption_key",
    "db.rotate_ssl_certs": "oci.database.DatabaseClient.rotate_ssl_certs",
    "db.rotate_vault_key": "oci.database.DatabaseClient.rotate_vault_key",
    "db.saas_admin_user_status": "oci.database.DatabaseClient.saas_admin_user_status",
    "db.scan_external_container_database_pluggable_databases": "oci.database.DatabaseClient.scan_external_container_database_pluggable_databases",
    "db.set_db_key_version": "oci.database.DatabaseClient.set_db_key_version",
    "db.set_pdb_key_version": "oci.database.DatabaseClient.set_pdb_key_version",
    "db.shrink_autonomous_database": "oci.database.DatabaseClient.shrink_autonomous_database",
    "db.start_autonomous_database": "oci.database.DatabaseClient.start_autonomous_database",
    "db.start_pluggable_database": "oci.database.DatabaseClient.start_pluggable_database",
    "db.stop_autonomous_database": "oci.database.DatabaseClient.stop_autonomous_database",
    "db.stop_pluggable_database": "oci.database.DatabaseClient.stop_pluggable_database",
    "db.switch_over_data_guard": "oci.database.DatabaseClient.switch_over_data_guard",
    "db.switchover_autonomous_container_database_dataguard": "oci.database.DatabaseClient.switchover_autonomous_container_database_dataguard",
    "db.switchover_autonomous_container_database_dataguard_association": "oci.database.DatabaseClient.switchover_autonomous_container_database_dataguard_association",
    "db.switchover_autonomous_database": "oci.database.DatabaseClient.switchover_autonomous_database",
    "db.switchover_data_guard_association": "oci.database.DatabaseClient.switchover_data_guard_association",
    "db.terminate_autonomous_container_database": "oci.database.DatabaseClient.terminate_autonomous_container_database",
    "db.terminate_autonomous_exadata_infrastructure": "oci.database.DatabaseClient.terminate_autonomous_exadata_infrastructure",
    "db.terminate_db_system": "oci.database.DatabaseClient.terminate_db_system",
    "db.unregister_cloud_vm_cluster_pkcs": "oci.database.DatabaseClient.unregister_cloud_vm_cluster_pkcs",
    "db.update_autonomous_container_database": "oci.database.DatabaseClient.update_autonomous_container_database",
    "db.update_autonomous_container_database_dataguard_association": "oci.database.DatabaseClient.update_autonomous_container_database_dataguard_association",
    "db.update_autonomous_database": "oci.database.DatabaseClient.update_autonomous_database",
    "db.update_autonomous_database_backup": "oci.database.DatabaseClient.update_autonomous_database_backup",
    "db.update_autonomous_database_regional_wallet": "oci.database.DatabaseClient.update_autonomous_database_regional_wallet",
    "db.update_autonomous_database_software_image": "oci.database.DatabaseClient.update_autonomous_database_software_image",
    "db.update_autonomous_database_wallet": "oci.database.DatabaseClient.update_autonomous_database_wallet",
    "db.update_autonomous_exadata_infrastructure": "oci.database.DatabaseClient.update_autonomous_exadata_infrastructure",
    "db.update_autonomous_vm_cluster": "oci.database.DatabaseClient.update_autonomous_vm_cluster",
    "db.update_backup": "oci.database.DatabaseClient.update_backup",
    "db.update_backup_destination": "oci.database.DatabaseClient.update_backup_destination",
    "db.update_cloud_autonomous_vm_cluster": "oci.database.DatabaseClient.update_cloud_autonomous_vm_cluster",
    "db.update_cloud_exadata_infrastructure": "oci.database.DatabaseClient.update_cloud_exadata_infrastructure",
    "db.update_cloud_vm_cluster": "oci.database.DatabaseClient.update_cloud_vm_cluster",
    "db.update_cloud_vm_cluster_iorm_config": "oci.database.DatabaseClient.update_cloud_vm_cluster_iorm_config",
    "db.update_console_connection": "oci.database.DatabaseClient.update_console_connection",
    "db.update_console_history": "oci.database.DatabaseClient.update_console_history",
    "db.update_data_guard": "oci.database.DatabaseClient.update_data_guard",
    "db.update_data_guard_association": "oci.database.DatabaseClient.update_data_guard_association",
    "db.update_database": "oci.database.DatabaseClient.update_database",
    "db.update_database_software_image": "oci.database.DatabaseClient.update_database_software_image",
    "db.update_db_home": "oci.database.DatabaseClient.update_db_home",
    "db.update_db_node": "oci.database.DatabaseClient.update_db_node",
    "db.update_db_system": "oci.database.DatabaseClient.update_db_system",
    "db.update_exadata_infrastructure": "oci.database.DatabaseClient.update_exadata_infrastructure",
    "db.update_exadata_iorm_config": "oci.database.DatabaseClient.update_exadata_iorm_config",
    "db.update_exadb_vm_cluster": "oci.database.DatabaseClient.update_exadb_vm_cluster",
    "db.update_exascale_db_storage_vault": "oci.database.DatabaseClient.update_exascale_db_storage_vault",
    "db.update_execution_action": "oci.database.DatabaseClient.update_execution_action",
    "db.update_execution_window": "oci.database.DatabaseClient.update_execution_window",
    "db.update_external_container_database": "oci.database.DatabaseClient.update_external_container_database",
    "db.update_external_database_connector": "oci.database.DatabaseClient.update_external_database_connector",
    "db.update_external_non_container_database": "oci.database.DatabaseClient.update_external_non_container_database",
    "db.update_external_pluggable_database": "oci.database.DatabaseClient.update_external_pluggable_database",
    "db.update_key_store": "oci.database.DatabaseClient.update_key_store",
    "db.update_maintenance_run": "oci.database.DatabaseClient.update_maintenance_run",
    "db.update_oneoff_patch": "oci.database.DatabaseClient.update_oneoff_patch",
    "db.update_pluggable_database": "oci.database.DatabaseClient.update_pluggable_database",
    "db.update_scheduled_action": "oci.database.DatabaseClient.update_scheduled_action",
    "db.update_scheduling_policy": "oci.database.DatabaseClient.update_scheduling_policy",
    "db.update_scheduling_window": "oci.database.DatabaseClient.update_scheduling_window",
    "db.update_vm_cluster": "oci.database.DatabaseClient.update_vm_cluster",
    "db.update_vm_cluster_network": "oci.database.DatabaseClient.update_vm_cluster_network",
    "db.upgrade_database": "oci.database.DatabaseClient.upgrade_database",
    "db.upgrade_db_system": "oci.database.DatabaseClient.upgrade_db_system",
    "db.validate_vm_cluster_network": "oci.database.DatabaseClient.validate_vm_cluster_network",
}
