# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates. All rights reserved.

SDK_client_map = {
    "iam.activate_domain": "oci.identity.IdentityClient.activate_domain",
    "iam.activate_mfa_totp_device": "oci.identity.IdentityClient.activate_mfa_totp_device",
    "iam.add_tag_default_lock": "oci.identity.IdentityClient.add_tag_default_lock",
    "iam.add_tag_namespace_lock": "oci.identity.IdentityClient.add_tag_namespace_lock",
    "iam.add_user_to_group": "oci.identity.IdentityClient.add_user_to_group",
    "iam.assemble_effective_tag_set": "oci.identity.IdentityClient.assemble_effective_tag_set",
    "iam.bulk_delete_resources": "oci.identity.IdentityClient.bulk_delete_resources",
    "iam.bulk_delete_tags": "oci.identity.IdentityClient.bulk_delete_tags",
    "iam.bulk_edit_tags": "oci.identity.IdentityClient.bulk_edit_tags",
    "iam.bulk_move_resources": "oci.identity.IdentityClient.bulk_move_resources",
    "iam.cascade_delete_tag_namespace": "oci.identity.IdentityClient.cascade_delete_tag_namespace",
    "iam.change_domain_compartment": "oci.identity.IdentityClient.change_domain_compartment",
    "iam.change_domain_license_type": "oci.identity.IdentityClient.change_domain_license_type",
    "iam.change_tag_namespace_compartment": "oci.identity.IdentityClient.change_tag_namespace_compartment",
    "iam.create_auth_token": "oci.identity.IdentityClient.create_auth_token",
    "iam.create_compartment": "oci.identity.IdentityClient.create_compartment",
    "iam.create_customer_secret_key": "oci.identity.IdentityClient.create_customer_secret_key",
    "iam.create_db_credential": "oci.identity.IdentityClient.create_db_credential",
    "iam.create_domain": "oci.identity.IdentityClient.create_domain",
    "iam.create_dynamic_group": "oci.identity.IdentityClient.create_dynamic_group",
    "iam.create_group": "oci.identity.IdentityClient.create_group",
    "iam.create_identity_provider": "oci.identity.IdentityClient.create_identity_provider",
    "iam.create_idp_group_mapping": "oci.identity.IdentityClient.create_idp_group_mapping",
    "iam.create_mfa_totp_device": "oci.identity.IdentityClient.create_mfa_totp_device",
    "iam.create_network_source": "oci.identity.IdentityClient.create_network_source",
    "iam.create_o_auth_client_credential": "oci.identity.IdentityClient.create_o_auth_client_credential",
    "iam.create_or_reset_ui_password": "oci.identity.IdentityClient.create_or_reset_ui_password",
    "iam.create_policy": "oci.identity.IdentityClient.create_policy",
    "iam.create_region_subscription": "oci.identity.IdentityClient.create_region_subscription",
    "iam.create_smtp_credential": "oci.identity.IdentityClient.create_smtp_credential",
    "iam.create_swift_password": "oci.identity.IdentityClient.create_swift_password",
    "iam.create_tag": "oci.identity.IdentityClient.create_tag",
    "iam.create_tag_default": "oci.identity.IdentityClient.create_tag_default",
    "iam.create_tag_namespace": "oci.identity.IdentityClient.create_tag_namespace",
    "iam.create_user": "oci.identity.IdentityClient.create_user",
    "iam.deactivate_domain": "oci.identity.IdentityClient.deactivate_domain",
    "iam.delete_api_key": "oci.identity.IdentityClient.delete_api_key",
    "iam.delete_auth_token": "oci.identity.IdentityClient.delete_auth_token",
    "iam.delete_compartment": "oci.identity.IdentityClient.delete_compartment",
    "iam.delete_customer_secret_key": "oci.identity.IdentityClient.delete_customer_secret_key",
    "iam.delete_db_credential": "oci.identity.IdentityClient.delete_db_credential",
    "iam.delete_domain": "oci.identity.IdentityClient.delete_domain",
    "iam.delete_dynamic_group": "oci.identity.IdentityClient.delete_dynamic_group",
    "iam.delete_group": "oci.identity.IdentityClient.delete_group",
    "iam.delete_identity_provider": "oci.identity.IdentityClient.delete_identity_provider",
    "iam.delete_idp_group_mapping": "oci.identity.IdentityClient.delete_idp_group_mapping",
    "iam.delete_mfa_totp_device": "oci.identity.IdentityClient.delete_mfa_totp_device",
    "iam.delete_network_source": "oci.identity.IdentityClient.delete_network_source",
    "iam.delete_o_auth_client_credential": "oci.identity.IdentityClient.delete_o_auth_client_credential",
    "iam.delete_policy": "oci.identity.IdentityClient.delete_policy",
    "iam.delete_smtp_credential": "oci.identity.IdentityClient.delete_smtp_credential",
    "iam.delete_swift_password": "oci.identity.IdentityClient.delete_swift_password",
    "iam.delete_tag": "oci.identity.IdentityClient.delete_tag",
    "iam.delete_tag_default": "oci.identity.IdentityClient.delete_tag_default",
    "iam.delete_tag_namespace": "oci.identity.IdentityClient.delete_tag_namespace",
    "iam.delete_user": "oci.identity.IdentityClient.delete_user",
    "iam.enable_replication_to_region": "oci.identity.IdentityClient.enable_replication_to_region",
    "iam.generate_totp_seed": "oci.identity.IdentityClient.generate_totp_seed",
    "iam.get_authentication_policy": "oci.identity.IdentityClient.get_authentication_policy",
    "iam.get_compartment": "oci.identity.IdentityClient.get_compartment",
    "iam.get_domain": "oci.identity.IdentityClient.get_domain",
    "iam.get_dynamic_group": "oci.identity.IdentityClient.get_dynamic_group",
    "iam.get_group": "oci.identity.IdentityClient.get_group",
    "iam.get_iam_work_request": "oci.identity.IdentityClient.get_iam_work_request",
    "iam.get_identity_provider": "oci.identity.IdentityClient.get_identity_provider",
    "iam.get_idp_group_mapping": "oci.identity.IdentityClient.get_idp_group_mapping",
    "iam.get_mfa_totp_device": "oci.identity.IdentityClient.get_mfa_totp_device",
    "iam.get_network_source": "oci.identity.IdentityClient.get_network_source",
    "iam.get_policy": "oci.identity.IdentityClient.get_policy",
    "iam.get_standard_tag_template": "oci.identity.IdentityClient.get_standard_tag_template",
    "iam.get_tag": "oci.identity.IdentityClient.get_tag",
    "iam.get_tag_default": "oci.identity.IdentityClient.get_tag_default",
    "iam.get_tag_namespace": "oci.identity.IdentityClient.get_tag_namespace",
    "iam.get_tagging_work_request": "oci.identity.IdentityClient.get_tagging_work_request",
    "iam.get_tenancy": "oci.identity.IdentityClient.get_tenancy",
    "iam.get_user": "oci.identity.IdentityClient.get_user",
    "iam.get_user_group_membership": "oci.identity.IdentityClient.get_user_group_membership",
    "iam.get_user_ui_password_information": "oci.identity.IdentityClient.get_user_ui_password_information",
    "iam.get_work_request": "oci.identity.IdentityClient.get_work_request",
    "iam.import_standard_tags": "oci.identity.IdentityClient.import_standard_tags",
    "iam.list_allowed_domain_license_types": "oci.identity.IdentityClient.list_allowed_domain_license_types",
    "iam.list_api_keys": "oci.identity.IdentityClient.list_api_keys",
    "iam.list_auth_tokens": "oci.identity.IdentityClient.list_auth_tokens",
    "iam.list_availability_domains": "oci.identity.IdentityClient.list_availability_domains",
    "iam.list_bulk_action_resource_types": "oci.identity.IdentityClient.list_bulk_action_resource_types",
    "iam.list_bulk_edit_tags_resource_types": "oci.identity.IdentityClient.list_bulk_edit_tags_resource_types",
    "iam.list_compartments": "oci.identity.IdentityClient.list_compartments",
    "iam.list_cost_tracking_tags": "oci.identity.IdentityClient.list_cost_tracking_tags",
    "iam.list_customer_secret_keys": "oci.identity.IdentityClient.list_customer_secret_keys",
    "iam.list_db_credentials": "oci.identity.IdentityClient.list_db_credentials",
    "iam.list_domains": "oci.identity.IdentityClient.list_domains",
    "iam.list_dynamic_groups": "oci.identity.IdentityClient.list_dynamic_groups",
    "iam.list_fault_domains": "oci.identity.IdentityClient.list_fault_domains",
    "iam.list_groups": "oci.identity.IdentityClient.list_groups",
    "iam.list_iam_work_request_errors": "oci.identity.IdentityClient.list_iam_work_request_errors",
    "iam.list_iam_work_request_logs": "oci.identity.IdentityClient.list_iam_work_request_logs",
    "iam.list_iam_work_requests": "oci.identity.IdentityClient.list_iam_work_requests",
    "iam.list_identity_provider_groups": "oci.identity.IdentityClient.list_identity_provider_groups",
    "iam.list_identity_providers": "oci.identity.IdentityClient.list_identity_providers",
    "iam.list_idp_group_mappings": "oci.identity.IdentityClient.list_idp_group_mappings",
    "iam.list_mfa_totp_devices": "oci.identity.IdentityClient.list_mfa_totp_devices",
    "iam.list_network_sources": "oci.identity.IdentityClient.list_network_sources",
    "iam.list_o_auth_client_credentials": "oci.identity.IdentityClient.list_o_auth_client_credentials",
    "iam.list_policies": "oci.identity.IdentityClient.list_policies",
    "iam.list_region_subscriptions": "oci.identity.IdentityClient.list_region_subscriptions",
    "iam.list_regions": "oci.identity.IdentityClient.list_regions",
    "iam.list_smtp_credentials": "oci.identity.IdentityClient.list_smtp_credentials",
    "iam.list_standard_tag_namespaces": "oci.identity.IdentityClient.list_standard_tag_namespaces",
    "iam.list_swift_passwords": "oci.identity.IdentityClient.list_swift_passwords",
    "iam.list_tag_defaults": "oci.identity.IdentityClient.list_tag_defaults",
    "iam.list_tag_namespaces": "oci.identity.IdentityClient.list_tag_namespaces",
    "iam.list_tagging_work_request_errors": "oci.identity.IdentityClient.list_tagging_work_request_errors",
    "iam.list_tagging_work_request_logs": "oci.identity.IdentityClient.list_tagging_work_request_logs",
    "iam.list_tagging_work_requests": "oci.identity.IdentityClient.list_tagging_work_requests",
    "iam.list_tags": "oci.identity.IdentityClient.list_tags",
    "iam.list_user_group_memberships": "oci.identity.IdentityClient.list_user_group_memberships",
    "iam.list_users": "oci.identity.IdentityClient.list_users",
    "iam.list_work_requests": "oci.identity.IdentityClient.list_work_requests",
    "iam.move_compartment": "oci.identity.IdentityClient.move_compartment",
    "iam.recover_compartment": "oci.identity.IdentityClient.recover_compartment",
    "iam.remove_tag_default_lock": "oci.identity.IdentityClient.remove_tag_default_lock",
    "iam.remove_tag_namespace_lock": "oci.identity.IdentityClient.remove_tag_namespace_lock",
    "iam.remove_user_from_group": "oci.identity.IdentityClient.remove_user_from_group",
    "iam.reset_idp_scim_client": "oci.identity.IdentityClient.reset_idp_scim_client",
    "iam.update_auth_token": "oci.identity.IdentityClient.update_auth_token",
    "iam.update_authentication_policy": "oci.identity.IdentityClient.update_authentication_policy",
    "iam.update_compartment": "oci.identity.IdentityClient.update_compartment",
    "iam.update_customer_secret_key": "oci.identity.IdentityClient.update_customer_secret_key",
    "iam.update_domain": "oci.identity.IdentityClient.update_domain",
    "iam.update_dynamic_group": "oci.identity.IdentityClient.update_dynamic_group",
    "iam.update_group": "oci.identity.IdentityClient.update_group",
    "iam.update_identity_provider": "oci.identity.IdentityClient.update_identity_provider",
    "iam.update_idp_group_mapping": "oci.identity.IdentityClient.update_idp_group_mapping",
    "iam.update_network_source": "oci.identity.IdentityClient.update_network_source",
    "iam.update_o_auth_client_credential": "oci.identity.IdentityClient.update_o_auth_client_credential",
    "iam.update_policy": "oci.identity.IdentityClient.update_policy",
    "iam.update_smtp_credential": "oci.identity.IdentityClient.update_smtp_credential",
    "iam.update_swift_password": "oci.identity.IdentityClient.update_swift_password",
    "iam.update_tag": "oci.identity.IdentityClient.update_tag",
    "iam.update_tag_default": "oci.identity.IdentityClient.update_tag_default",
    "iam.update_tag_namespace": "oci.identity.IdentityClient.update_tag_namespace",
    "iam.update_user": "oci.identity.IdentityClient.update_user",
    "iam.update_user_capabilities": "oci.identity.IdentityClient.update_user_capabilities",
    "iam.update_user_state": "oci.identity.IdentityClient.update_user_state",
    "iam.upload_api_key": "oci.identity.IdentityClient.upload_api_key",
}
